VERSION 5.00
Begin VB.Form frmSuperMenu 
   BackColor       =   &H00F9FCFC&
   BorderStyle     =   0  'None
   Caption         =   "Form2"
   ClientHeight    =   870
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1635
   LinkTopic       =   "Form2"
   ScaleHeight     =   870
   ScaleWidth      =   1635
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Interval        =   100
      Left            =   120
      Top             =   120
   End
End
Attribute VB_Name = "frmSuperMenu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


'==============================================================================================
' Referencias / crditos
'==============================================================================================
    '------------------------------------------------------
    'modulo de clase
    'Name.......... cSuperClass
    'Author........ Paul_Caton@hotmail.com
    'Date.......... June, 13th 2002
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    

'==============================================================================================
' --------------------------------------------------------------------------------------------------------------
' Mdulo cSuperClass // Declaraciones
' --------------------------------------------------------------------------------------------------------------
'==============================================================================================
Private Enum eMsgWhen                                                   'When to callback
    MSG_BEFORE = 1                                                        'Callback before the original WndProc
    MSG_AFTER = 2                                                         'Callback after the original WndProc
    MSG_BEFORE_AFTER = MSG_BEFORE Or MSG_AFTER                            'Callback before and after the original WndProc
End Enum

Private Enum eThunkType
    SubclassThunk = 0
    HookThunk = 1
    CallbackThunk = 2
End Enum

Private z_IDEflag           As Long         'Flag indicating we are in IDE
Private z_ScMem             As Long         'Thunk base address
Private z_scFunk            As Collection   'hWnd/thunk-address collection
Private z_hkFunk            As Collection   'hook/thunk-address collection
Private z_cbFunk            As Collection   'callback/thunk-address collection
Private Const IDX_INDEX     As Long = 2     'index of the subclassed hWnd OR hook type
Private Const IDX_CALLBACKORDINAL As Long = 22 ' Ubound(callback thunkdata)+1, index of the callback

Private Const IDX_WNDPROC   As Long = 9     'Thunk data index of the original WndProc
Private Const IDX_BTABLE    As Long = 11    'Thunk data index of the Before table
Private Const IDX_ATABLE    As Long = 12    'Thunk data index of the After table
Private Const IDX_PARM_USER As Long = 13    'Thunk data index of the User-defined callback parameter data index
Private Const IDX_UNICODE   As Long = 75    'Must be Ubound(subclass thunkdata)+1; index for unicode support
Private Const ALL_MESSAGES  As Long = -1    'All messages callback
Private Const MSG_ENTRIES   As Long = 32    'Number of msg table entries. Set to 1 if using ALL_MESSAGES for all subclassed windows

Private Declare Sub RtlMoveMemory Lib "kernel32" (ByVal Destination As Long, ByVal Source As Long, ByVal Length As Long)
Private Declare Function IsBadCodePtr Lib "kernel32" (ByVal lpFn As Long) As Long
Private Declare Function VirtualAlloc Lib "kernel32" (ByVal lpAddress As Long, ByVal dwSize As Long, ByVal flAllocationType As Long, ByVal flProtect As Long) As Long
Private Declare Function VirtualFree Lib "kernel32" (ByVal lpAddress As Long, ByVal dwSize As Long, ByVal dwFreeType As Long) As Long
Private Declare Function GetModuleHandleA Lib "kernel32" (ByVal lpModuleName As String) As Long
Private Declare Function GetModuleHandleW Lib "kernel32" (ByVal lpModuleName As Long) As Long
Private Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long
Private Declare Function CallWindowProcA Lib "user32" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal MSG As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function CallWindowProcW Lib "user32" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal MSG As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function GetCurrentProcessId Lib "kernel32" () As Long
Private Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hwnd As Long, lpdwProcessId As Long) As Long
Private Declare Function IsWindow Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function IsWindowUnicode Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function SendMessageA Lib "user32.dll" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByRef lParam As Any) As Long
Private Declare Function SendMessageW Lib "user32.dll" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByRef lParam As Any) As Long
Private Declare Function SetWindowLongA Lib "user32" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SetWindowLongW Lib "user32" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long


' mensajes
' --------------------------------------------------------------------------------------------------------------
Private Const WM_MOUSEWHEEL = &H20A
Private Const WM_VSCROLL As Integer = &H115

Private Const WM_DESTROY        As Long = &H2
Private Const WM_CLOSE          As Long = &H10
Private Const WM_NCLBUTTONDOWN  As Long = &HA1
Private Const WM_MOUSEMOVE      As Long = &H200
Private Const WM_LBUTTONDBLCLK  As Long = &H203
Private Const WM_LBUTTONDOWN    As Long = &H201
Private Const WM_LBUTTONUP      As Long = &H202
Private Const WM_MBUTTONDBLCLK  As Long = &H209
Private Const WM_MBUTTONDOWN    As Long = &H207
Private Const WM_MBUTTONUP      As Long = &H208
Private Const WM_RBUTTONDBLCLK  As Long = &H206
Private Const WM_RBUTTONDOWN    As Long = &H204
Private Const WM_RBUTTONUP      As Long = &H205
Private Const WM_MOVING         As Long = &H216
Private Const WM_PAINT          As Long = &HF&
Private Const WM_SETFONT        As Long = &H30
Private Const WM_ERASEBKGND     As Long = &H14

' Mensajes cuando se cierra el men o se despliega el men de sistema ( para ocultarlo - Se usa en wndProc)
' --------------------------------------------------------------------------------------------------------------
Private Const WM_SYSCOMMAND = &H112
Private Const SC_CLOSE = &HF060&


'==============================================================================================' --------------------------------------------------------------------------------------------------------------
' Fin declaraciones cSuperClass
' --------------------------------------------------------------------------------------------------------------
'==============================================================================================


'==============================================================================================
' --------------------------------------------------------------------------------------------------------------
' Declaraciones para las funciones  del Men
' --------------------------------------------------------------------------------------------------------------
'==============================================================================================

' --------------------------------------------------------------------------------------------------------------
' Constantes
' --------------------------------------------------------------------------------------------------------------
Private Const GWL_WNDPROC = (-4)
Private Const GWL_STYLE = (-16)
Private Const WS_CHILD = &H40000000

' para la ventana transparente
Private Const GWL_EXSTYLE = (-20)
Private Const LWA_ALPHA = &H2
Private Const WS_EX_LAYERED = &H80000


'==============================================================================================
' -------------------------------------------------------------------------------------------'''''''''''''''''''''''''
' Types y enums
' -------------------------------------------------------------------------------------------'''''''''''''''''''''''''
'==============================================================================================

' para setwindowpos ( onTop )
Private Const HWND_TOPMOST = -1
Private Const HWND_NOTOPMOST = -2
Private Const SWP_NOSIZE = &H1
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOACTIVATE = &H10
Private Const SWP_SHOWWINDOW = &H40

' para dibujar texto
Private Const DT_CENTER = &H1
Private Const DT_CALCRECT = &H400

' estilos de la ventana
Private Const CS_DROPSHADOW     As Long = &H20000
Private Const GCL_STYLE         As Long = -26

' texto con transparencia ( funcin pvAlphaBlend)
Private Type UcsRgbQuad
    r                   As Byte
    G                   As Byte
    b                   As Byte
    a                   As Byte
End Type

' usos varios ( para setRect)
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Enum eAlignText
    [eAlignLeft] = 0
    [eAlignCenter] = 1
    [eAlignRight] = 2
End Enum

' usos varios (getCursorPos)
Private Type POINTAPI
    X As Long
    Y As Long
End Type

' Paleta de color del sistema ( api ChooseColor )
Private Type CHOOSECOLOR
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    rgbResult As Long
    lpCustColors As String
    flags As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

' Tipo de men ( de uso interno )
Private Enum ShowMenuType
    Show_Grid = 0
    Show_Color = 1
    Show_FontList = 2
    Show_Size = 3
    show_Smyles = 4
    Show_options = 5
End Enum

'==============================================================================================
' -------------------------------------------------------------------------------------------'''''''''''''''''''''''''
' Declaraciones Apis
' -------------------------------------------------------------------------------------------'''''''''''''''''''''''''
'==============================================================================================

' Para desplegar la Paleta de sistema
Private Declare Function CHOOSECOLOR Lib "comdlg32.dll" Alias "ChooseColorA" (pChoosecolor As CHOOSECOLOR) As Long

' Para recuperar y cambiar los estilos de la ventana del formulario
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function GetClassLong Lib "user32" Alias "GetClassLongA" (ByVal lngHandler As Long, ByVal lngIndex As Long) As Long
Private Declare Function SetClassLong Lib "user32" Alias "SetClassLongA" (ByVal lngHandler As Long, ByVal lngIndex As Long, ByVal lngNewClassLong As Long) As Long

' Para recuperar el handle de la ventana que tiene el foco ( control asociado al men )
Private Declare Function GetFocus Lib "user32" () As Long

' para saber si una ventana se encuentra visible
Private Declare Function IsWindowVisible Lib "user32" (ByVal hwnd As Long) As Long

' para cambiar las coordenadas del form a las coordenadas de la pantalla
Private Declare Function ClientToScreen Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long

' para recuperar las coordenadas del mouse
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long

' para dibujar texto en un HDC
Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long

' para copiar en una estructura rect los valores de un rectngulo
Private Declare Function SetRect Lib "user32" (lpRect As RECT, ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long) As Long

' dibujar un rectngulo ( para el borde general del men  para las opciones )
Private Declare Function Rectangle Lib "gdi32" (ByVal hdc As Long, ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long) As Long
Private Declare Function OleTranslateColor Lib "oleaut32.dll" (ByVal lOleColor As Long, ByVal lHPalette As Long, ByVal lColorRef As Long) As Long
' se usa en pvAlphaBlend
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByVal Destination As Long, ByVal Source As Long, ByVal Length As Long)

' para saber si el puntero se encuentra dentro de un rectngulo ( para las opciones del men )
Private Declare Function PtInRect Lib "user32" (lpRect As RECT, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Long, ByVal yPoint As Long) As Long

Private Declare Sub SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)

' para dibujar cada una de las imagenes contenidas en el imagelist en un HDC ( en el form de men)
Private Declare Function ImageList_Draw Lib "comctl32.dll" (ByVal himl As Long, ByVal i As Long, ByVal hdcDst As Long, ByVal X As Long, ByVal Y As Long, ByVal fStyle As Long) As Long

' Para establecer transparencia al formulario
Private Declare Function SetLayeredWindowAttributes Lib "user32" (ByVal hwnd As Long, ByVal crKey As Long, ByVal bAlpha As Byte, ByVal dwFlags As Long) As Long

'==============================================================================================
'-------------------------------------------------------------------------------------------'''
' Fin de declaraciones API
'-------------------------------------------------------------------------------------------'''
'==============================================================================================



'==============================================================================================
'-------------------------------------------------------------------------------------------'''
' Variables
'-------------------------------------------------------------------------------------------'''
'==============================================================================================


'-------------------------------------------------------------------------------------------'''

' valores de retorno de los menus

'-------------------------------------------------------------------------------------------'''
Private ResultSize                      As Long             ' Men de tamao de fuente
Private ResultFontName                  As String           ' Men de tipo de fuente
Private MoreColor                       As Boolean          ' Men color
Private ResultColor                     As Long             ' Men de color
Private ResultSmyle                     As Long             ' Men de imagen
Private Rec()                           As RECT             ' almacena los rectngulo para las opciones del men
Private iFont()                         As String           ' valores de los nombres de fuente
Private iColor()                        As Long             ' Para las celdas de color

Private mIndexMenuOption                As Integer

Private m_sMenuType                     As ShowMenuType     ' tipo de men
Private StyleForm                       As Long
Private m_ObjImageList                  As Object           ' ImageList
Private index                           As Long

Private TablaX                          As Long             ' valores para el men Grid
Private TablaY                          As Long
Private Cancelar                        As Boolean
Private m_CotrolHwnd                    As Long             ' Handle del control asociado al men
Private m_hwndOwner                     As Long             ' Handle del objeto contenedor en donde se despliega el men
Private mCol                            As Long             ' Columnas para el Grid
Private mRow                            As Long             ' Filas para el Grid
Private mCellSize                       As Long             ' tamao de la celda para el Grid
Private mArrFontList()                  As String           ' array con las fuentes a mostrar en el men de lista de fuentes

' Colores para el men ( color de fondo, color de fondo de la seleccin, y los bordes )
Private mBackColorMenu                  As Long
Private mBorderColorMenu                As Long
Private mBackColorMenuSelected          As Long
Private mBorderColorMenuSelected        As Long

' Cantidad de columnas a mostrar en el men de lista de imgenes ( para le image list)
Private mMaxColCountImagesList          As Integer
' Cantidad de columnas a mostrar en el men de paleta de color
Private mColCountColors                 As Integer

' Color de fuente para el menu > Tamao de fuente
Private mForeColorNotmalMenu            As Long

' Guardar valor de la transparencia
Private mTransFrm                       As Byte
' alineacin de texto
Private mAlignText                      As eAlignText

' valor por defecto seleccionado
Private mSelectedMenuFont               As String
Private mSelectedMenuFontSize           As Integer
Private mSelectedMenuOptions            As Integer
Private mSelectedColor                  As Long
Private mSelectedImage                  As Integer

'==============================================================================================
' ---------------------------------------------------------------------------------------------
' Fin de declaraciones
' ---------------------------------------------------------------------------------------------
'==============================================================================================



'------------------------------------------------------------------------------------------------


'==============================================================================================
' ---------------------------------------------------------------------------------------------
' Funciones y rutinas para el  Men
' ---------------------------------------------------------------------------------------------
'==============================================================================================


' ' -------------------------------------------------------------------------------------------
' Men para mostrar el grid
' ' -------------------------------------------------------------------------------------------


Public Function ShowMenuGrid( _
    ByVal lhwndOwner As Long, _
    ByVal X As Long, _
    ByVal Y As Long, _
    lRowCount As Long, _
    lColCount As Long, _
    lCellSize As Long, _
    iRow As Integer, _
    iCol As Integer, _
    Optional lBackColorMenu As Long, _
    Optional lBorderColorMenu As Long, _
    Optional lBackColorMenuSelected As Long, _
    Optional lBorderColorMenuSelected As Long, _
    Optional TransparentValue As Byte = 255) As Boolean
        
    ' .. si ya est el men visible ..salir
    If Not Me.Visible Then
            
        ' valor de transparencia del formulario
        mTransFrm = TransparentValue
                    
        ' Establecer valor de colores en las variables para usarlas luego ..
        Me.BackColor = lBackColorMenu
        mBackColorMenu = Me.BackColor
        mBorderColorMenu = lBorderColorMenu
        mBackColorMenuSelected = lBackColorMenuSelected
        mBorderColorMenuSelected = lBorderColorMenuSelected
        
        ' Cantidad de filas y columnas
        mRow = lRowCount
        mCol = lColCount
        
        'tamao de la celda
        mCellSize = lCellSize
        
        ' Chequear valores mnimos
        If mRow <= 0 Then mRow = 1
        If mCol <= 0 Then mCol = 1
        If mCellSize < 15 Then mCellSize = 15
        
        ' Guardar Handle del contenedor del men
        m_hwndOwner = lhwndOwner
        
        
        TablaX = 0
        TablaY = 0
        
        ' Crear y Mostrar men
        Call ShowPopMenu(Show_Grid, lhwndOwner, X, Y)
        
        ' Entrar en un bucle y esperar hasta que se oculte el men
        Call LoopToEvent
        
        ' retornar valores y descargar
        If TablaX Or TablaY Then
            ShowMenuGrid = True
            iRow = TablaY
            iCol = TablaX
        End If
        
        Unload Me
    End If
End Function


' ---------------------------------------------------------------------------------------------

' Men para seleccionar fuentes

' ---------------------------------------------------------------------------------------------

Public Function ShowMenuFontList( _
    ByVal lhwndOwner As Long, _
    ByVal X As Long, _
    ByVal Y As Long, _
    Optional sSelectedValue As String = vbNullString, _
    Optional iFontSize As Integer, _
    Optional pArrayFontList As Variant, _
    Optional lForeColor As Long = vbBlack, _
    Optional lBackColorMenu As Long, _
    Optional lBorderColorMenu As Long, _
    Optional lBackColorMenuSelected As Long, _
    Optional lBorderColorMenuSelected As Long, _
    Optional TransparentValue As Byte = 255) As String
    
    
    If Not Me.Visible Then
        
        mSelectedMenuFont = sSelectedValue
        ' valor de transparencia del formulario
        mTransFrm = TransparentValue
        
        Cancelar = False
        
        ' Establecer valor de colores en las variables para usarlas luego en la funcin que dibuja el men
        Me.BackColor = lBackColorMenu
        mBackColorMenu = Me.BackColor
        mBorderColorMenu = lBorderColorMenu
        mBackColorMenuSelected = lBackColorMenuSelected
        mBorderColorMenuSelected = lBorderColorMenuSelected
        mForeColorNotmalMenu = lForeColor
        
        ' Establecer el tamao de fuente
        With Me
            If Not IsMissing(iFontSize) Then .FontSize = iFontSize
        End With
        
        ' Cargar las fuentes pasadas como parmetro en el array, si no cargar algunas por defecto
        If Not IsMissing(pArrayFontList) Then
           ReDim iFont(0)
           Dim xFont As Variant
           For Each xFont In pArrayFontList
               iFont(UBound(iFont)) = xFont
               ReDim Preserve iFont(UBound(iFont) + 1)
           Next
           ReDim Preserve iFont(UBound(iFont) - 1)
           ' fuentes cuando no se pasa el array
        Else
           ReDim iFont(8)
           iFont(0) = "Arial"
           iFont(1) = "Arial Black"
           iFont(2) = "Courier new"
           iFont(3) = "Helvetica"
           iFont(4) = "Lucida Console"
           iFont(5) = "Georgia"
           iFont(6) = "Tahoma"
           iFont(7) = "Times New Roman"
           iFont(8) = "Verdana"
        End If
    
        ' Guardar el Handle del contenedor del men
        m_hwndOwner = lhwndOwner
        
        ' Crar y Mostrar el men
        Call ShowPopMenu(Show_FontList, m_hwndOwner, X, Y)
        
        ' Entrar en un bucle hasta que se oculte el men
        Call LoopToEvent
        
        ' retornar el valor y descargar el  formulario
        If Not Cancelar Then
            ShowMenuFontList = ResultFontName
        End If
        Unload Me
    End If
           
End Function


' ---------------------------------------------------------------------------------------------

' Men para seleccionar fuentes

' ---------------------------------------------------------------------------------------------

Public Function ShowMenuOptions( _
    ByVal lhwndOwner As Long, _
    pArrayOptions As Variant, _
    ByVal X As Long, _
    ByVal Y As Long, _
    Optional iSelectedValue As Integer = -1, _
    Optional iFontSize As Integer, _
    Optional sFontName As String, _
    Optional lAlignText As eAlignText = 1, _
    Optional lForeColor As Long = vbBlack, _
    Optional lBackColorMenu As Long, _
    Optional lBorderColorMenu As Long, _
    Optional lBackColorMenuSelected As Long, _
    Optional lBorderColorMenuSelected As Long, _
    Optional TransparentValue As Byte = 255) As Integer
    
    
    If Not Me.Visible Then
        
        mSelectedMenuOptions = iSelectedValue
        mAlignText = lAlignText
        
        ' valor de transparencia del formulario
        mTransFrm = TransparentValue
        
        Cancelar = False
        
        ' Establecer valor de colores en las variables para usarlas luego en la funcin que dibuja el men
        Me.BackColor = lBackColorMenu
        mBackColorMenu = Me.BackColor
        mBorderColorMenu = lBorderColorMenu
        mBackColorMenuSelected = lBackColorMenuSelected
        mBorderColorMenuSelected = lBorderColorMenuSelected
        mForeColorNotmalMenu = lForeColor
        
        ' Establecer el tamao de fuente
        With Me
            If Not IsMissing(iFontSize) Then
                If iFontSize < 8 Then iFontSize = 8
                .Font.Size = iFontSize
            End If
            If Not IsMissing(sFontName) Then
                .Font.Name = sFontName
            End If
        End With
        
        ' Cargar las fuentes pasadas como parmetro en el array, si no cargar algunas por defecto
        ReDim iFont(0)
        Dim xFont As Variant
        For Each xFont In pArrayOptions
            iFont(UBound(iFont)) = " " & xFont & " "
            ReDim Preserve iFont(UBound(iFont) + 1)
        Next
        ReDim Preserve iFont(UBound(iFont) - 1)
    
        ' Guardar el Handle del contenedor del men
        m_hwndOwner = lhwndOwner
        
        ' Crar y Mostrar el men
        Call ShowPopMenu(Show_options, m_hwndOwner, X, Y)
        
        
        
        ' Entrar en un bucle hasta que se oculte el men
        ' ---------------------------------------------------------------------------------------------
        Call LoopToEvent
        
        
        
        ' retornar el valor y descargar el  formulario
        If Not Cancelar Then
            ShowMenuOptions = mIndexMenuOption
        End If
        Unload Me
    End If
           
End Function



' -------------------------------------------------------------------------------------------

' Men para mostrar el dilogo de paleta de color

' -------------------------------------------------------------------------------------------
Public Function ShowMenuPaleteColor( _
    ByVal lhwndOwner As Long, _
    ByVal X As Long, _
    ByVal Y As Long, _
    Optional lSelectedValue As Long = -1, _
    Optional vArrayListColors As Variant, _
    Optional iColumns As Integer = 8, _
    Optional lCellSize As Integer = 16, _
    Optional lForeColor As Long = vbBlack, _
    Optional lBackColorMenu As Long, _
    Optional lBorderColorMenu As Long, _
    Optional lBackColorMenuSelected As Long, _
    Optional lBorderColorMenuSelected As Long, _
    Optional TransparentValue As Byte = 255) As Long
    
    Dim ResColor As Long
    ' si ya est el men visible salir
    If Me.Visible Then
        ShowMenuPaleteColor = -1
        Exit Function
    Else
        
        mSelectedColor = lSelectedValue
        
        ' Columnas a mostrar
        mColCountColors = iColumns
        If mColCountColors = 0 Then mColCountColors = 1
        
        ' Tamao de la celda
        mCellSize = lCellSize
        If mCellSize = 0 Or mCellSize < 16 Then mCellSize = 16
        
        
        ReDim iColor(0)
        
        ' Chequear si se pas un array de colores, si no us runo por defecto
        If Not IsMissing(vArrayListColors) Then
            Dim xColors As Variant
            For Each xColors In vArrayListColors
                        
                iColor(UBound(iColor)) = CLng(xColors)
                ReDim Preserve iColor(UBound(iColor) + 1)
            
            Next
        
            If UBound(iColor) > 0 Then ReDim Preserve iColor(UBound(iColor) - 1)
        End If
        
        ' valor de transparencia del formulario
        mTransFrm = TransparentValue
    
        ' Establecer valor de colores en las variables para usarlas luego en la funcin que dibuja el men
        Me.BackColor = lBackColorMenu
        mBackColorMenu = Me.BackColor
        mBorderColorMenu = lBorderColorMenu
        mBackColorMenuSelected = lBackColorMenuSelected
        mBorderColorMenuSelected = lBorderColorMenuSelected
        mForeColorNotmalMenu = lForeColor
        
        ' Hwnd del contenedor del men
        m_hwndOwner = lhwndOwner
        
        ' Crear y mostrar el men
        Call ShowPopMenu(Show_Color, lhwndOwner, X, Y)
        
        
        ' ---------------------------------------------------------------------------------------------
        ' Entrar en un bucle hasta que se oculte el men
        ' ---------------------------------------------------------------------------------------------
        Call LoopToEvent
        
        ' Si se seleccion mas colores, mostrar el dilogo de colores de windows, retornar y descargar el formulario
        If MoreColor Then
            ResColor = ShowDialogColor(lhwndOwner)
            If ResColor <> -1 Then
                ShowMenuPaleteColor = ResColor
            Else
                ShowMenuPaleteColor = -1
            End If
        Else
            ShowMenuPaleteColor = ResultColor
        End If

        Unload Me
    End If
    
End Function


' -------------------------------------------------------------------------------------------

' Men para mostrar imgenes cargadas en un ImageList

' -------------------------------------------------------------------------------------------

Public Function showMenuImageList( _
    ByVal lhwndOwner As Long, _
    ByVal X As Long, _
    ByVal Y As Long, _
    Imagelist As Object, _
    iMaxColCountImagesList As Integer, _
    Optional iSelectedValue As Integer = -1, _
    Optional lBackColorMenu As Long, _
    Optional lBorderColorMenu As Long, _
    Optional lBackColorMenuSelected As Long, _
    Optional lBorderColorMenuSelected As Long, _
    Optional TransparentValue As Byte = 255) As Long
    
    If Not Me.Visible Then
        
        mSelectedImage = iSelectedValue
        ' valor de transparencia del formulario
        mTransFrm = TransparentValue
            
        ' cantidad de columnas de las imgenes
        mMaxColCountImagesList = iMaxColCountImagesList
        
        ' Guardar valores para los colores del men
        Me.BackColor = lBackColorMenu
        mBackColorMenu = lBackColorMenu
        mBorderColorMenu = lBorderColorMenu
        mBackColorMenuSelected = lBackColorMenuSelected
        mBorderColorMenuSelected = lBorderColorMenuSelected
        
        ' Hwnd del contenedor del men
        m_hwndOwner = lhwndOwner
        
        ' crear y mostrar el men
        Call ShowPopMenu(show_Smyles, lhwndOwner, X, Y, Imagelist)
        
        ' entrar en un bucle hasta que se oculte el men
        Call LoopToEvent
        
        ' retornar el ndice de la imagen seleccionada
        showMenuImageList = ResultSmyle
        
        ' descargar
        Unload Me
    End If
    
End Function

' -------------------------------------------------------------------------------------------

' Men para mostrar la lista de tamaos de fuentes

' -------------------------------------------------------------------------------------------

Public Function ShowMenuFontSize( _
    lhwndOwner As Long, _
    ByVal X As Long, _
    ByVal Y As Long, _
    Optional iSelectedValue As Integer = -1, _
    Optional sFontName As String = "Verdana", _
    Optional bFontBold As Boolean = False, _
    Optional bFontUderline As Boolean = False, _
    Optional bFontItalic As Boolean = False, _
    Optional bFontStrikethrough As Boolean = False, _
    Optional lForeColor As Long = vbBlack, _
    Optional lBackColorMenu As Long, _
    Optional lBorderColorMenu As Long, _
    Optional lBackColorMenuSelected As Long, _
    Optional lBorderColorMenuSelected As Long, _
    Optional TransparentValue As Byte = 255) As Long


    If Not Me.Visible Then
    
       mSelectedMenuFontSize = iSelectedValue

        ' valor de transparencia del formulario
       mTransFrm = TransparentValue
    
       ' colores del men ( BackColor, bordes)
       Me.BackColor = lBackColorMenu
       mBackColorMenu = Me.BackColor
       mBorderColorMenu = lBorderColorMenu
       mBackColorMenuSelected = lBackColorMenuSelected
       mBorderColorMenuSelected = lBorderColorMenuSelected
        
       ' Establecer Propiedades de fuente para el frm
       With Me
            .Font.Name = sFontName
            .FontBold = bFontBold
            .FontUnderline = bFontUderline
            .FontItalic = bFontItalic
            .FontStrikethru = bFontStrikethrough
            mForeColorNotmalMenu = lForeColor
        End With
    
       ' hwnd del contenedor del frmmen
       m_hwndOwner = lhwndOwner
       
       ' crear y mostrar el men
       Call ShowPopMenu(Show_Size, m_hwndOwner, X, Y)
       
       ' Entrar en espera hasta que se oculte
       Call LoopToEvent
       
       ' retornar el tamao de fuente seleccionado
       If ResultSize > 0 Then ShowMenuFontSize = iFont(ResultSize - 1)
       ' salir
       Unload Me
    End If
    
End Function


' -------------------------------------------------------------------------------------------

' Bucle que queda en espera hsata que se oculte el FrmMenu

' -------------------------------------------------------------------------------------------

Private Sub LoopToEvent()
    
    'Guardar Handle del control asociado al men ( el que tiene el foco)
    m_CotrolHwnd = GetFocus
    
    SetWindowLong Me.hwnd, GWL_STYLE, GetWindowLong(Me.hwnd, GWL_STYLE) Or WS_CHILD
    
    ' Subclasificar el contenedor del FrmMenu
    Call SubClass(m_hwndOwner)
    
    ' Subclasificar el control que tiene el foco ( el control asociado al men : CommandButton, combo etc ..)
    Call SubClass(m_CotrolHwnd)
    
    ' bucle de espera hasta que se oculte el frmMenu
    Do While Me.Visible = True
        DoEvents
    Loop
    
    ' Terminar los hooks
    Call UnSubClass
End Sub


' -------------------------------------------------------------------------------------------

' Dilogo de colores de windows cuando se selecciona ' mas colores'

' -------------------------------------------------------------------------------------------
Public Function ShowDialogColor(ByVal hwndOwner As Long) As Long

    Dim CustomColors() As Byte
    Dim cc As CHOOSECOLOR
    Dim Custcolor(16) As Long
    Dim lReturn As Long
    
    With cc
        .lStructSize = Len(cc)
        .hwndOwner = hwndOwner
        .hInstance = App.hInstance
        .lpCustColors = StrConv(CustomColors, vbUnicode)
        .flags = 2
    End With
    
    If CHOOSECOLOR(cc) <> 0 Then
        ShowDialogColor = cc.rgbResult
        CustomColors = StrConv(cc.lpCustColors, vbFromUnicode)
    Else
        ShowDialogColor = -1
    End If
End Function


' -------------------------------------------------------------------------------------------

' Funcin para retornar un color con transparencia

' -------------------------------------------------------------------------------------------

Private Function pvAlphaBlend(ByVal clrFirst As Long, ByVal clrSecond As Long, ByVal lAlpha As Long) As Long
    Dim clrFore         As UcsRgbQuad
    Dim clrBack         As UcsRgbQuad
    
    OleTranslateColor clrFirst, 0, VarPtr(clrFore)
    OleTranslateColor clrSecond, 0, VarPtr(clrBack)
    With clrFore
        .r = (.r * lAlpha + clrBack.r * (255 - lAlpha)) / 255
        .G = (.G * lAlpha + clrBack.G * (255 - lAlpha)) / 255
        .b = (.b * lAlpha + clrBack.b * (255 - lAlpha)) / 255
    End With
    CopyMemory VarPtr(pvAlphaBlend), VarPtr(clrFore), 4
End Function


' -------------------------------------------------------------------------------------------
' ' Ocultar frm men cuando se desactiva
' -------------------------------------------------------------------------------------------

Private Sub Form_Deactivate()
    Me.Visible = False
End Sub




' ---------------------------------------------------------------------------------------------
' Funcin general para llamar a cada men
' ---------------------------------------------------------------------------------------------

Private Sub ShowPopMenu( _
    sMenuType As ShowMenuType, _
    ByVal hwndOwner As Long, _
    ByVal X As Long, _
    ByVal Y As Long, _
    Optional Imagelist As Object)

Dim i As Integer
Dim XX As Long
Dim YY As Long
Dim ClientPT As POINTAPI
Dim lWidthText As Long
Dim lHeightText As Long
    
    
    ' Propiedades del formulario
    ' ---------------------------------------------------------------------------------------------
    With Me
        .FillStyle = 0 ' relleno slido para usar con la funcin Rectangle
        .ScaleMode = 3 ' modo de escala en pixeles
        .AutoRedraw = True ' establecer el AutoRedraw para mantener los dibujado
    End With
    
    m_sMenuType = sMenuType
    
    Call ClientToScreen(hwndOwner, ClientPT)
    index = -1
    
    ' Tipos de men
    ' ---------------------------------------------------------------------------------------------
    Select Case m_sMenuType
        
        
        ' ---------------------------------------------------------------------------------------------
        ' Tabla
        ' ---------------------------------------------------------------------------------------------
        Case Show_Grid
            
            ' Posicionar el formulario
            With Screen
                Me.Move _
                    (ClientPT.X * .TwipsPerPixelX + X), _
                    (ClientPT.Y * .TwipsPerPixelY + Y), _
                    ((mCellSize * mCol) + 4) * .TwipsPerPixelX, _
                    ((mCellSize * mRow) + 50) * .TwipsPerPixelY
            End With
            
            ' dibujar la tabla
            Call DrawGrid(0, 0)
        
        
        
        
        ' ---------------------------------------------------------------------------------------------
        ' Paleta
        ' ---------------------------------------------------------------------------------------------
        
        Case Show_Color
            
            MoreColor = False
            ResultColor = -1
            Me.FontSize = 10
            
            If UBound(iColor) = 0 Then
            
                'Array para almacenar los colores
                ReDim iColor(42)
                ' llenar el array de colores
                iColor(0) = 1578: iColor(1) = &H3399: iColor(2) = &H3333
                iColor(3) = &H3300: iColor(4) = &H663300: iColor(5) = &H800000
                iColor(6) = &H993333: iColor(7) = &H333333: iColor(8) = &H80
                iColor(9) = &H66FF: iColor(10) = &H8080&: iColor(11) = &H808080
                iColor(12) = &H808000: iColor(13) = &HFF0000: iColor(14) = &H996666
                iColor(15) = 69547: iColor(16) = &HFF: iColor(17) = &H99FF&
                iColor(18) = &HCC99&: iColor(19) = &H669933: iColor(20) = &HCCCC33
                iColor(21) = &HFF6633: iColor(22) = &H800080: iColor(23) = &H999999
                iColor(24) = &HFF00FF: iColor(25) = &HCCFF&: iColor(26) = &HFFFF&
                iColor(27) = &HFF00&: iColor(28) = &HFFFF00: iColor(29) = &HFFCC00
                iColor(30) = &H663399: iColor(31) = &HC0C0C0: iColor(32) = &HCC99FF
                iColor(33) = &H99CCFF: iColor(34) = &H99FFFF: iColor(35) = &HCCFFCC
                iColor(36) = &HFFFFCC: iColor(37) = &HFFCC99: iColor(38) = &HFF99CC
                iColor(39) = &HFFFFFF: iColor(40) = &H0
            
            Else
                ReDim Preserve iColor(UBound(iColor) + 3)
            End If
            
            'Array para almacenar los rectngulos
            ReDim Rec(UBound(iColor))
            
            
            ' para el cuadradito de 'Automtico'
            Call SetRect(Rec(UBound(iColor)), 7, 7, 21, 21)
            
            ' posicin inicial para el alto del Frm
            Dim lFrmHeight As Long
            Dim lFrmWidth  As Long
            lFrmHeight = 48 + (mCellSize + 6)
            lFrmWidth = (mColCountColors * (mCellSize + 6)) + 8
            
            ' cargar valores de los rectngulos para cada celda de color
            Dim x1 As Long
            Dim x2 As Long
            Dim y1 As Long
            Dim y2 As Long
            
            y1 = 24
            
            For i = 0 To UBound(iColor) - 3
                If XX = mColCountColors Then
                    XX = 0
                    YY = YY + 1
                    y1 = y2
                    lFrmHeight = lFrmHeight + (mCellSize + 6)
                End If
                x1 = ((mCellSize + 6) * XX) + 4
                x2 = x1 + (mCellSize + 6)
                y2 = y1 + (mCellSize + 6)
                
                Call SetRect(Rec(i), x1, y1, x2, y2)
                
                'Debug.Print ((20 * XX) + 4)
                'Debug.Print ((20 * YY) + 24)
                'Debug.Print ((20 * XX) + 24)
                'Debug.Print (20 * YY) + 20 + 24
                'Debug.Print "--"
                
                
                XX = XX + 1
                
            Next
            
            ' Posicionar el formulario
            With Screen
                Me.Move _
                    (ClientPT.X * .TwipsPerPixelX + X), _
                    (ClientPT.Y * .TwipsPerPixelY + Y), lFrmWidth * .TwipsPerPixelX, lFrmHeight * .TwipsPerPixelY
            End With
            
            ' para el botn 'Automtico'
            Call SetRect(Rec(UBound(iColor) - 2), 4, 4, lFrmWidth - 4, 24)
            
            ' para el botn 'Mas colores'
            Call SetRect(Rec(UBound(iColor) - 1), 4, (Me.Height / 15) - 24, lFrmWidth - 4, (Me.Height / 15) - 4)
            
            
            ' dibujar la paleta
            Call DrawPaleteColors(0, 0)
        
        
        ' ---------------------------------------------------------------------------------------------
        ' Listas de fuentes
        ' ---------------------------------------------------------------------------------------------
        Case Show_FontList
                 
            ' redimensionar el array que guarda los rectngulos para cada fuente
            ReDim Rec(UBound(iFont))
            
            ' valor de retorno de la fuente
            ResultFontName = ""
            
            ' recorrer el array de lista de fuentes
            For i = 0 To UBound(iFont)
                Me.Font.Name = iFont(i) ' cambiar la fuente para poder usar TextWidth y TextHeight
                
                ' Guardar la opcin de men con mas altura y mas anchura
                If lWidthText < Me.TextWidth(iFont(i)) + 1 Then lWidthText = Me.TextWidth(iFont(i)) + 1
                If lHeightText < Me.TextHeight(iFont(i)) + 1 Then lHeightText = Me.TextHeight(iFont(i)) + 1
            Next
            
            ' Posicionar el frmMenu
            With Me
                .Left = ClientPT.X * Screen.TwipsPerPixelX + X
                .Top = ClientPT.Y * Screen.TwipsPerPixelY + Y
                .Width = (lWidthText * Screen.TwipsPerPixelX) + 240
                .Font.Name = iFont(0)
                Call SetRect(Rec(0), 2, 2, .ScaleWidth - 2, lHeightText)
            End With
            
            ' Llnar el array con los rectngulos para cada opcin
            For i = 1 To UBound(iFont)
                Call SetRect(Rec(i), 2, CLng(Rec(i - 1).Bottom) + 2, Me.ScaleWidth - 2, lHeightText * (i + 1))
            Next
            
            ' establecer altura del forlmulario
            Me.Height = (lHeightText * (UBound(Rec) + 1) * Screen.TwipsPerPixelY) + 30
            
            ' dibujar la lista de fuentes
            Call DrawFontList(0, 0)



        ' ---------------------------------------------------------------------------------------------
        ' Listas de opciones
        ' ---------------------------------------------------------------------------------------------
        Case Show_options
                 
            ' redimensionar el array que guarda los rectngulos para cada fuente
            ReDim Rec(UBound(iFont))
            
            ' valor de retorno de la fuente
            mIndexMenuOption = -1
            
            ' recorrer el array de lista de fuentes
            For i = 0 To UBound(iFont)
                
                ' Guardar la opcin de men con mas altura y mas anchura
                If lWidthText < Me.TextWidth(iFont(i)) + 1 Then lWidthText = Me.TextWidth(iFont(i)) + 1
                If lHeightText < Me.TextHeight(iFont(i)) + 1 Then lHeightText = Me.TextHeight(iFont(i)) + 1
            Next
            
            lHeightText = lHeightText + 8
            
            ' Posicionar el frmMenu
            With Me
                .Left = ClientPT.X * Screen.TwipsPerPixelX + X
                .Top = ClientPT.Y * Screen.TwipsPerPixelY + Y
                .Width = (lWidthText * Screen.TwipsPerPixelX) + 240
                Call SetRect(Rec(0), 2, 2, .ScaleWidth - 2, lHeightText)
            End With
            
            ' cargar el array con los rectngulos para cada opcin
            For i = 1 To UBound(iFont)
                Call SetRect(Rec(i), 2, CLng(Rec(i - 1).Bottom) + 2, Me.ScaleWidth - 2, lHeightText * (i + 1))
            Next
            
            ' establecer altura del forlmulario
            Me.Height = (lHeightText * (UBound(Rec) + 1) * Screen.TwipsPerPixelY) + 30
            
            ' dibujar la lista de fuentes
            Call DrawOptions(0, 0)


        ' ---------------------------------------------------------------------------------------------
        ' Listas de tamaos de fuente
        ' ---------------------------------------------------------------------------------------------

        Case Show_Size
            
            ' array con los rectngulos para cada opcin
            
            
            ' array con los valores de los FontSize para cada opcin
            ReDim iFont(8)
            
            ' setear retorno
            ResultSize = 0
            
            ' llenar tamaos
            iFont(0) = 8
            iFont(1) = 10
            iFont(2) = 12
            iFont(3) = 14
            iFont(4) = 18
            iFont(5) = 20
            iFont(6) = 24
            iFont(7) = 30
            iFont(8) = 32
            
            With Me
                For i = LBound(iFont) To UBound(iFont)
                    .Font.Size = iFont(i)
                    ' comprobar mximo de alto y ancho de las opciones
                    If lWidthText < Me.TextWidth("Tamao " & CStr(i)) + 1 Then lWidthText = Me.TextWidth("Tamao " & CStr(i)) + 1
                Next
                
                ' posicionar FrmMenu
                .Left = ClientPT.X * Screen.TwipsPerPixelX + X
                .Top = ClientPT.Y * Screen.TwipsPerPixelY + Y
                .Width = (lWidthText * Screen.TwipsPerPixelX) + 240
            
            End With
            
            
            Me.Font.Size = iFont(0)
            lHeightText = 20
            
            ReDim Rec(UBound(iFont))
            
            ' Establecer rectngulos para cada opcin
            ' '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
            Call SetRect(Rec(0), 2, 2, Me.ScaleWidth - 2, lHeightText)
            
            ' Establecer rectngulos para cada opcin
            For i = 1 To UBound(iFont)
                Me.FontSize = iFont(i)
                
                lHeightText = lHeightText + Me.TextHeight("Tamao " & CStr(i)) + 2
                Call SetRect(Rec(i), 2, CLng(Rec(i - 1).Bottom) + 2, Me.ScaleWidth - 2, lHeightText)
            Next
            
            'Establecer alto del formulario
            Me.Height = ((Rec(UBound(iFont)).Bottom + 2) * Screen.TwipsPerPixelY)
            
            ' dibujar el men
            Call DrawFontSize(0, 0)
        
        
        
        ' ---------------------------------------------------------------------------------------------
        ' Men de imgenes cargadas en ImageList
        ' ---------------------------------------------------------------------------------------------
        
        Case show_Smyles
             
            ' Referencia al ImageList
            Set m_ObjImageList = Imagelist
            
            With m_ObjImageList
                
                ' Redimensionar array que guarda los valores para los rectngulos de cada imagen
                ReDim Rec(.ListImages.Count)
                
                ResultSmyle = 0
                
                ' recorrer imgenes en el imageList
                For i = 1 To .ListImages.Count
                    
                    ' Cargar los Rect con los valores para los rectngulos de cada imagen
                    Call SetRect( _
                        Rec(i - 1), _
                        ((.ImageWidth + 6) * XX) + 10, _
                        ((.ImageHeight + 6) * YY) + 10, _
                        ((.ImageWidth + 6) * XX) + (19 + 6) + 10, _
                        ((.ImageHeight + 6) * YY) + (19 + 6) + 10)
                    
                    ' Incrementar columna
                    XX = XX + 1
                    
                    ' comprobar que no se pase
                    If XX = mMaxColCountImagesList Then
                        XX = 0
                        If i <> .ListImages.Count Then
                            YY = YY + 1
                        End If
                    End If
                Next
                
            End With
            
            ' Posicionar y redimensionar el formulario
            ' ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
            
            Me.Move _
                (ClientPT.X * Screen.TwipsPerPixelX + X), _
                (ClientPT.Y * Screen.TwipsPerPixelY + Y), _
                ((((m_ObjImageList.ImageWidth + 6) * mMaxColCountImagesList) + 20) * Screen.TwipsPerPixelX), _
                (((m_ObjImageList.ImageHeight + 6) * (YY + 1)) + 20) * Screen.TwipsPerPixelY
            
            ' Dibujar men con las imgenes
            ' ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
            Call DrawSmyles(0, 0)
    End Select
    
    
    ' Poner por encima la ventana
    Call SetWindowPos(Me.hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE Or SWP_SHOWWINDOW Or SWP_NOMOVE Or SWP_NOSIZE)
    
    ' Establecer trnasparencia
    If mTransFrm < 255 Then
        Call SetTrans(Me.hwnd, mTransFrm)
    End If
End Sub


' ---------------------------------------------------------------------------------------------
' Dibujar el men de imagenes
' ---------------------------------------------------------------------------------------------
Private Sub DrawSmyles(ByVal X As Long, ByVal Y As Long)
Dim i As Integer
Dim XX As Long
Dim YY As Long
    
    ' Rectngulo grande
    With Me
        .FillColor = .BackColor
        .ForeColor = mBorderColorMenu
         Call Rectangle(.hdc, 0, 0, .ScaleWidth, .ScaleHeight)
        .FillColor = mBackColorMenuSelected
        .ForeColor = mBorderColorMenuSelected
    End With
    
    ' Recorrer imagelist
    For i = 1 To m_ObjImageList.ListImages.Count
        With m_ObjImageList
            
            ' calcular cordenadas y tamao de la imagen actual
            Dim x1 As Long, y1 As Long, x2 As Long, y2 As Long
            
            x1 = ((.ImageWidth + 6) * XX) + 10
            y1 = ((.ImageHeight + 6) * YY) + 10
            x2 = ((.ImageWidth + 6) * XX) + (.ImageWidth + 6) + 10
            y2 = ((.ImageHeight + 6) * YY) + (.ImageHeight + 6) + 10
        
            Call SetRect(Rec(i - 1), x1, y1, x2, y2)
    
            If PtInRect(Rec(i - 1), X, Y) Or mSelectedImage = i Then
                Rectangle Me.hdc, Rec(i - 1).Left, Rec(i - 1).Top, Rec(i - 1).Right, Rec(i - 1).Bottom
            End If
            ' dibujar la imagen del image list en el form
            'm_ObjImageList.ListImages(i).Draw Me.hdc, Rec(i - 1).Left + 3, Rec(i - 1).Top + 3, 1
            Call ImageList_Draw(.hImageList, _
                                (i - 1), _
                                (Me.hdc), (Rec(i - 1).Left + 3), _
                                (Rec(i - 1).Top + 3), 1)
        End With
    
        XX = XX + 1
        
        ' comprobar las columnas
        If XX = mMaxColCountImagesList Then
            XX = 0
            YY = YY + 1
        End If
    Next
    
    Me.Refresh

End Sub


'-------------------------------------------------------------------------------
' Dibujar paleta de color
'-------------------------------------------------------------------------------
Private Sub DrawPaleteColors(ByVal X As Long, ByVal Y As Long)
    Dim i As Integer
        
    ' Rectngulo grande
    With Me
        .FillColor = .BackColor
        .ForeColor = mBorderColorMenu
        Call Rectangle(.hdc, 0, 0, .ScaleWidth, .ScaleHeight)
    End With
    
    ' Recorrer array con la lista de valores de color
    For i = 0 To UBound(iColor) - 1
        
        ' Dibujar la seleccin
        If (PtInRect(Rec(i), X, Y)) Or (index = i) Then
            Me.FillColor = mBackColorMenuSelected
            Me.ForeColor = mBorderColorMenuSelected
            Rectangle hdc, Rec(i).Left, Rec(i).Top, Rec(i).Right, Rec(i).Bottom
            Me.ForeColor = mBorderColorMenu
            index = i
        End If
        If (mSelectedColor) = iColor(i) Then
             
            Me.FillColor = mBackColorMenuSelected
            Me.ForeColor = mBorderColorMenuSelected
            Rectangle hdc, Rec(i).Left, Rec(i).Top, Rec(i).Right, Rec(i).Bottom
            Me.ForeColor = mBorderColorMenu
        End If
        ' dibujar los colores
        If i < (UBound(iColor) - 2) Then
            Me.FillColor = iColor(i)
            Call Rectangle(hdc, Rec(i).Left + 3, Rec(i).Top + 3, Rec(i).Right - 3, Rec(i).Bottom - 3)
        End If
    Next
    
    ' dibujar texto 'Automtico' y 'mas colores'
    If PtInRect(Rec(UBound(iColor) - 2), X, Y) Or index = (UBound(iColor) - 2) Then
        Me.ForeColor = vbHighlightText
    Else
        Me.ForeColor = vbWindowText
    End If
    
    Dim strTextButton As String
    
    ' comprobar ancho del frmMenu que no sea menor al texto
    strTextButton = "Automtico"
    If (Me.TextWidth(strTextButton) + 30) < (Rec(UBound(iColor) - 2).Right) Then
       Me.ForeColor = mForeColorNotmalMenu
       Call DrawText(hdc, strTextButton, Len(strTextButton), Rec(UBound(iColor) - 2), DT_CENTER)
    End If
    
    If (PtInRect(Rec(UBound(iColor) - 1), X, Y)) Or _
       (index = (UBound(iColor) - 1)) Then
        Me.ForeColor = vbHighlightText
    Else
        Me.ForeColor = vbWindowText
    End If
    
    Me.ForeColor = mForeColorNotmalMenu
    If (Me.TextWidth("Ms Colores...")) < (Rec(UBound(iColor) - 1).Right) Then
        strTextButton = "Ms Colores..."
    Else
        strTextButton = " + "
    End If
    
    Call DrawText(hdc, strTextButton, Len(strTextButton), Rec(UBound(iColor) - 1), DT_CENTER)
    
    With Me
        
        .FillColor = .BackColor
        .ForeColor = mBorderColorMenu
    
        Call Rectangle(.hdc, _
                        Rec(UBound(iColor)).Left, _
                        Rec(UBound(iColor)).Top, _
                        Rec(UBound(iColor)).Right, _
                        Rec(UBound(iColor)).Bottom)

        .Refresh
    End With
    
End Sub


'-------------------------------------------------------------------------------
' Dibujar men de lista de fuentes
'-------------------------------------------------------------------------------


Private Sub DrawFontList(ByVal X As Long, ByVal Y As Long)
    Dim i As Integer
    Dim j As Integer
    Dim Label As String
    Dim tRec As RECT
        
    ' rectngulo grande
    With Me
        .FillColor = .BackColor
        .ForeColor = mBorderColorMenu
        Call Rectangle(.hdc, 0, 0, .ScaleWidth, .ScaleHeight)
    End With
    
    ' recorrer lista de fuentes
    For i = 0 To UBound(iFont)
        ' Opcin actual done est el mouse
        If PtInRect(Rec(i), X, Y) Or _
            (index = i) Or _
            (Trim(LCase(mSelectedMenuFont)) = Trim(LCase(iFont(i)))) Then
            
            Me.FillColor = mBackColorMenuSelected
            Me.ForeColor = mBorderColorMenuSelected
            index = i
            ' dems opciones
        Else
            Me.FillColor = Me.BackColor
            Me.ForeColor = mBorderColorMenu
        End If
        
        On Error Resume Next
        Me.Font.Name = iFont(i)
        On Error GoTo 0
        
        ' calcular rectngulo y dibujar el texto
        Label = iFont(i)
        
        SetRect tRec, 0, 0, 0, 0
        DrawText Me.hdc, Label, Len(Label), tRec, DT_CALCRECT
        
        ' dibujar rectngulo
        Rectangle hdc, Rec(i).Left, Rec(i).Top, Rec(i).Right, Rec(i).Bottom
        
        Dim medio As Single
        medio = Rec(i).Top + ((Rec(i).Bottom - Rec(i).Top) / 2) - (tRec.Bottom / 2)
        
        SetRect tRec, Rec(i).Left, medio, Rec(i).Right, medio + tRec.Bottom
        
        If PtInRect(Rec(i), X, Y) Or index = i Then
            Me.ForeColor = vbHighlightText
        Else
            Me.ForeColor = vbWindowText
        End If
        Me.ForeColor = mForeColorNotmalMenu
        Call DrawText(Me.hdc, Label, Len(Label), tRec, DT_CENTER)
    Next
    
    Me.Refresh
End Sub


'-------------------------------------------------------------------------------
' Dibujar men de opciones
'-------------------------------------------------------------------------------

Private Sub DrawOptions(ByVal X As Long, ByVal Y As Long)
    Dim i As Integer
    Dim j As Integer
    Dim Label As String
    Dim tRec As RECT
    
    ' Rectngulo grande
    With Me
        .FillColor = .BackColor
        .ForeColor = mBorderColorMenu
        Call Rectangle(.hdc, 0, 0, .ScaleWidth, .ScaleHeight)
    End With
    
    ' recorrer array con la lista de opciones
    For i = 0 To UBound(iFont)
        
        ' Opcin seleccionada
        If (PtInRect(Rec(i), X, Y)) Or _
           (index = i) Or _
           (mSelectedMenuOptions = i) Then
            Me.FillColor = mBackColorMenuSelected
            Me.ForeColor = mBorderColorMenuSelected
            index = i
        Else
            ' Dems opciones
            Me.FillColor = Me.BackColor
            Me.ForeColor = mBorderColorMenu
        End If
        
        
        ' Caption de la opcin actual
        Label = iFont(i)
        
        ' establecer rectngulo para el texto y dibujar
        SetRect tRec, 0, 0, 0, 0
        DrawText Me.hdc, Label, Len(Label), tRec, DT_CALCRECT
        Rectangle hdc, Rec(i).Left, Rec(i).Top, Rec(i).Right, Rec(i).Bottom
        
        Dim medio As Single
        medio = Rec(i).Top + ((Rec(i).Bottom - Rec(i).Top) / 2) - (tRec.Bottom / 2)
        
        SetRect tRec, Rec(i).Left, medio, Rec(i).Right, medio + tRec.Bottom
        
        If PtInRect(Rec(i), X, Y) Or index = i Then
            Me.ForeColor = vbHighlightText
        Else
            Me.ForeColor = vbWindowText
        End If
        Me.ForeColor = mForeColorNotmalMenu
        Call DrawText(Me.hdc, Label, Len(Label), tRec, mAlignText)
        
    Next
    
    Me.Refresh
End Sub


'-------------------------------------------------------------------------------
' dibujar men de tamaos de fuente
'-------------------------------------------------------------------------------

Private Sub DrawFontSize(ByVal X As Long, ByVal Y As Long)
    Dim i As Integer
    Dim j As Integer
    Dim Label As String
    
    ' Dibujar rectngulo grande
    With Me
        .FillColor = .BackColor
        .ForeColor = mBorderColorMenu
        Call Rectangle(.hdc, 0, 0, .ScaleWidth, .ScaleHeight)
    End With
    
    ' recorrer la lista de tamaos de fuente
    '-------------------------------------------------------------------------------
    For i = 0 To UBound(iFont)
        ' Opcin actual
        If (PtInRect(Rec(i), X, Y)) Or _
           (index = i) Or _
           (mSelectedMenuFontSize = iFont(i)) Then
            Me.FillColor = mBackColorMenuSelected
            Me.ForeColor = mBorderColorMenuSelected
            
            index = i
        Else
        ' normal
            Me.FillColor = Me.BackColor
            Me.ForeColor = mBorderColorMenu
        End If
        
        ' dibujar rectngulo
        Rectangle hdc, Rec(i).Left, Rec(i).Top, Rec(i).Right, Rec(i).Bottom
        
        ' Setear fuente y dibujar el caption
        Label = "Tamao " & i + 1
        Me.FontSize = iFont(i)
        
        If PtInRect(Rec(i), X, Y) Or index = i Then
            Me.ForeColor = vbHighlightText
        Else
            Me.ForeColor = vbWindowText
        End If
        
        Me.ForeColor = mForeColorNotmalMenu
        
        DrawText Me.hdc, Label, Len(Label), Rec(i), DT_CENTER
    Next
        
    Me.Refresh

End Sub



Private Sub Form_Load()
    StyleForm = GetClassLong(Me.hwnd, GCL_STYLE)
    SetClassLong Me.hwnd, GCL_STYLE, StyleForm Or CS_DROPSHADOW
End Sub

'-------------------------------------------------------------------------------
' Terminar
'-------------------------------------------------------------------------------
Private Sub Form_Terminate()
    Call ssc_Terminate
    Call scb_TerminateCallbacks
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Call SetClassLong(Me.hwnd, GCL_STYLE, StyleForm)
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = 1 Then
        Select Case m_sMenuType
            ' para cuando se hace clic en el lmite inferior de la grilla
            Case Show_Grid
                If Y > Me.ScaleHeight - 20 Then
                    Me.Visible = False
                End If
        End Select
    End If
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    Dim XWidth As Long
    Dim YHeight As Long
    Dim CurrX As Long
    Dim CurrY As Long

    Select Case m_sMenuType
        Case Show_Grid
            If Button = 1 Then
                Timer1.Interval = 0
                If X > Me.ScaleWidth Then
                    XWidth = X / 15
                    Me.Width = ((XWidth * 15) + 4) * Screen.TwipsPerPixelX
                End If
                If Y > Me.ScaleHeight - 15 Then
                    YHeight = Y / 15
                    Me.Height = ((YHeight * 15) + 50) * Screen.TwipsPerPixelY
                End If
            Else
                Timer1.Interval = 100
            End If
    
            If Y < Me.ScaleHeight - 20 Then Call DrawGrid(X, Y)
            
        Case Show_Color
            Timer1.Interval = 100
            Call DrawPaleteColors(X, Y)
        Case Show_FontList
            Call DrawFontList(X, Y)
            Timer1.Interval = 100
        Case Show_options
            Call DrawOptions(X, Y)
            Timer1.Interval = 100
        Case Show_Size
            Call DrawFontSize(X, Y)
            Timer1.Interval = 100
        Case show_Smyles
            Call DrawSmyles(X, Y)
            Timer1.Interval = 100
    End Select

End Sub



'-------------------------------------------------------------------------------
' crear Grid, Crear al comienzo y cuando se mueve el mouse para dibujar la seleccin
'-------------------------------------------------------------------------------

Private Sub DrawGrid(ByVal X As Long, ByVal Y As Long)
    Dim i As Integer
    Dim j As Integer
    Dim Rec As RECT
    Dim Label As String
        
     ' Setear fuente del form y dibujar rectngulo grande
    ''-------------------------------------------------------------------------------
    With Me
        .Font.Name = "MS Sans Serif"
        .FillColor = .BackColor
        .ForeColor = mBorderColorMenu
        Call Rectangle(.hdc, 0, 0, .ScaleWidth, .ScaleHeight)
    End With
    
    TablaX = 0
    TablaY = 0
    
    ' Recorrer columnas y filas
    '-------------------------------------------------------------------------------
    For i = 0 To mCol - 1
            
        For j = 0 To mRow - 1
            If (X > (i * mCellSize) + 2) And (Y > (j * mCellSize) + 2) Then
                Me.FillColor = mBackColorMenuSelected
                Me.ForeColor = mBorderColorMenuSelected
                TablaX = i + 1
                TablaY = j + 1
            Else
                Me.FillColor = Me.BackColor
                Me.ForeColor = mBorderColorMenu
            End If
                
            ' Dibujar celda
            Rectangle hdc, (i * mCellSize) + 4, (j * mCellSize) + 4, (i * mCellSize) + mCellSize, (j * mCellSize) + mCellSize
        Next
    Next
    
    ' cuando se saca el mouse fuera del men no mostrar nada
    If TablaX = 0 And TablaY = 0 Then
        Label = vbNullString
    Else
        Label = TablaX & "x" & TablaY
    End If
    
    ' Dibujar texto indicador de tabla
    SetRect Rec, 0, Me.ScaleHeight - 18, Me.ScaleWidth, Me.ScaleHeight
    Me.ForeColor = vbWindowText
    DrawText Me.hdc, Label, Len(Label), Rec, DT_CENTER
    
    ' refrescar
    Me.Refresh


End Sub


'-------------------------------------------------------------------------------
' Retornar valores al seleccionar los elementos del men, .... y salir
'-------------------------------------------------------------------------------

Private Sub Form_Mouseup(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    Dim i As Integer
    
    If Button = 1 Then
        Select Case m_sMenuType
            '-------------------------------------------------------------------------------
            ' Grilla
            '-------------------------------------------------------------------------------
            Case Show_Grid
                Me.Visible = False
             
            '-------------------------------------------------------------------------------
             ' Paleta de color
            '-------------------------------------------------------------------------------
            Case Show_Color
                For i = 0 To UBound(iColor) - 1
                    If PtInRect(Rec(i), X, Y) Then
                        If i = (UBound(iColor) - 1) Then
                            MoreColor = True
                        Else
                            ResultColor = iColor(i)
                        End If
                        Me.Visible = False
                        Exit For
                    End If
                Next
                
            '-------------------------------------------------------------------------------
            ' Lista de fuentes
            '-------------------------------------------------------------------------------
            Case Show_FontList
                For i = 0 To UBound(iFont)
                    If PtInRect(Rec(i), X, Y) Then
                        ResultFontName = iFont(i)
                        Me.Visible = False
                        Exit For
                    End If
                Next
            '-------------------------------------------------------------------------------
            ' Opciones
            '-------------------------------------------------------------------------------
            Case Show_options
                For i = 0 To UBound(iFont)
                    If PtInRect(Rec(i), X, Y) Then
                        mIndexMenuOption = i
                        Me.Visible = False
                        Exit For
                    End If
                Next
                            
            '-------------------------------------------------------------------------------
            ' Tamaos de fuente
            '-------------------------------------------------------------------------------
            Case Show_Size
                For i = 0 To UBound(iFont)
                    If PtInRect(Rec(i), X, Y) Then
                        ResultSize = i + 1
                        Me.Visible = False
                        Exit For
                    End If
                Next
                            
            '-------------------------------------------------------------------------------
            ' Lista de imgenes
            '-------------------------------------------------------------------------------
            Case show_Smyles
                For i = 0 To UBound(Rec)
                    If PtInRect(Rec(i), X, Y) Then
                        ResultSmyle = i + 1
                        Me.Visible = False
                        Exit For
                    End If
                Next
        End Select
    End If
End Sub



'-------------------------------------------------------------------------------
' Timer que comprueba cuando se sale del men para dibujar el men por defecto sin seleccin
'-------------------------------------------------------------------------------

Private Sub Timer1_Timer()
    Dim pt As POINTAPI
    Dim ClientPT As POINTAPI
    Dim InForm As Boolean
    
    'Index = -1
    ' obtener posicin del puntero
    GetCursorPos pt
    ' ' retorna True o False si se est dentro del hwnd indicado
    InForm = WindowFromPoint(pt.X, pt.Y) = Me.hwnd
    
    Select Case m_sMenuType
        Case Show_Grid
            ClientToScreen Me.hwnd, ClientPT
            
            pt.X = pt.X - ClientPT.X
            pt.Y = pt.Y - ClientPT.Y
            
            If pt.X < 0 Or pt.Y < 0 Or pt.X > Me.ScaleWidth Or pt.Y > Me.ScaleHeight - 20 Then
                Call DrawGrid(0, 0)
            End If
        Case Show_Color
            If Not InForm Then index = -1: DrawPaleteColors 0, 0
        Case Show_FontList
            If Not InForm Then index = -1: DrawFontList 0, 0
        Case Show_Size
            If Not InForm Then index = -1: DrawFontSize 0, 0
        Case show_Smyles
            If Not InForm Then index = -1: DrawSmyles 0, 0
    End Select
Timer1.Interval = 0
End Sub

Private Sub SelectIndex(ByVal New_Index As Long)
    index = index + New_Index

    If index > UBound(Rec) Then index = 0
    If index < 0 Then index = UBound(Rec)
    
    Select Case m_sMenuType
        Case Show_Grid
        Case Show_Color: Call DrawPaleteColors(0, 0)
        Case Show_FontList: Call DrawFontList(0, 0)
        Case Show_Size: Call DrawFontSize(0, 0)
    End Select
End Sub

Private Sub Acept()
Dim i As Integer

    Select Case m_sMenuType
        Case Show_Color
            If index > -1 Then
                If index = 41 Then
                    MoreColor = True
                Else
                    ResultColor = iColor(index)
                End If
                Me.Visible = False
            End If
        Case Show_FontList
            If index > -1 Then
                ResultFontName = iFont(index)
            End If
            Me.Visible = False
        Case Show_Size
            If index > -1 Then
               ResultSize = index + 1
            End If
            Me.Visible = False
    End Select
End Sub


'-------------------------------------------------------------------------------------------'''''''''
'-------------------------------------------------------------------------------------------'''''''''
' Establecer transparencia al men
' -------------------------------------------------------------------------------------------'''''''''
' -------------------------------------------------------------------------------------------'''''''''

Function SetTrans(ByVal lHwnd As Long, lValue As Byte) As Long
    
    Dim lStyle As Long
    lStyle = GetWindowLong(lHwnd, GWL_EXSTYLE)
    lStyle = lStyle Or WS_EX_LAYERED
      
    Call SetWindowLong(lHwnd, GWL_EXSTYLE, lStyle)
    Call SetLayeredWindowAttributes(lHwnd, 0, lValue, LWA_ALPHA)
End Function



'*******************************************************************************************************************
' -------------------------------------------------------------------------------------------'''''''''
' -------------------------------------------------------------------------------------------'''''''''
' Rutinas y funciones de cSuperClass
' -------------------------------------------------------------------------------------------'''''''''
' -------------------------------------------------------------------------------------------'''''''''
'*******************************************************************************************************************


'-The following routines are exclusively for the ssc_subclass routines----------------------------
Private Function ssc_Subclass(ByVal lng_hWnd As Long, _
       Optional ByVal lParamUser As Long = 0, _
       Optional ByVal nOrdinal As Long = 1, _
       Optional ByVal oCallback As Object = Nothing, _
       Optional ByVal bIdeSafety As Boolean = True, _
       Optional ByVal bUnicode As Boolean = False) As Boolean 'Subclass the specified window handle

    '*************************************************************************************************
    '* lng_hWnd   - Handle of the window to subclass
    '* lParamUser - Optional, user-defined callback parameter
    '* nOrdinal   - Optional, ordinal index of the callback procedure. 1 = last private method, 2 = second last private method, etc.
    '* oCallback  - Optional, the object that will receive the callback. If undefined, callbacks are sent to this object's instance
    '* bIdeSafety - Optional, enable/disable IDE safety measures. NB: you should really only disable IDE safety in a UserControl for design-time subclassing
    '* bUnicode - Optional, if True, Unicode API calls will be made to the window vs ANSI calls
    '*************************************************************************************************
    '* cSelfSub - self-subclassing class template
    '* Paul_Caton@hotmail.com
    '* Copyright free, use and abuse as you see fit.
    '*
    '* v1.0 Re-write of the SelfSub/WinSubHook-2 submission to Planet Source Code............ 20060322
    '* v1.1 VirtualAlloc memory to prevent Data Execution Prevention faults on Win64......... 20060324
    '* v1.2 Thunk redesigned to handle unsubclassing and memory release...................... 20060325
    '* v1.3 Data array scrapped in favour of property accessors.............................. 20060405
    '* v1.4 Optional IDE protection added
    '*      User-defined callback parameter added
    '*      All user routines that pass in a hWnd get additional validation
    '*      End removed from zError.......................................................... 20060411
    '* v1.5 Added nOrdinal parameter to ssc_Subclass
    '*      Switched machine-code array from Currency to Long................................ 20060412
    '* v1.6 Added an optional callback target object
    '*      Added an IsBadCodePtr on the callback address in the thunk prior to callback..... 20060413
    '*************************************************************************************************
    ' Subclassing procedure must be declared identical to the one at the end of this class (Sample at Ordinal #1)

    ' \\LaVolpe - reworked routine a bit, revised the ASM to allow auto-unsubclass on WM_DESTROY
    Dim z_Sc(0 To IDX_UNICODE) As Long                 'Thunk machine-code initialised here
    Const CODE_LEN      As Long = 4 * IDX_UNICODE      'Thunk length in bytes
    
    Const MEM_LEN       As Long = CODE_LEN + (8 * (MSG_ENTRIES))  'Bytes to allocate per thunk, data + code + msg tables
    Const PAGE_RWX      As Long = &H40&                'Allocate executable memory
    Const MEM_COMMIT    As Long = &H1000&              'Commit allocated memory
    Const MEM_RELEASE   As Long = &H8000&              'Release allocated memory flag
    Const IDX_EBMODE    As Long = 3                    'Thunk data index of the EbMode function address
    Const IDX_CWP       As Long = 4                    'Thunk data index of the CallWindowProc function address
    Const IDX_SWL       As Long = 5                    'Thunk data index of the SetWindowsLong function address
    Const IDX_FREE      As Long = 6                    'Thunk data index of the VirtualFree function address
    Const IDX_BADPTR    As Long = 7                    'Thunk data index of the IsBadCodePtr function address
    Const IDX_OWNER     As Long = 8                    'Thunk data index of the Owner object's vTable address
    Const IDX_CALLBACK  As Long = 10                   'Thunk data index of the callback method address
    Const IDX_EBX       As Long = 16                   'Thunk code patch index of the thunk data
    Const GWL_WNDPROC   As Long = -4                   'SetWindowsLong WndProc index
    Const WNDPROC_OFF   As Long = &H38                 'Thunk offset to the WndProc execution address
    Const SUB_NAME      As String = "ssc_Subclass"     'This routine's name
    
    Dim nAddr         As Long
    Dim nID           As Long
    Dim nMyID         As Long

    If IsWindow(lng_hWnd) = 0 Then                      'Ensure the window handle is valid
        zError SUB_NAME, "Invalid window handle"
        Exit Function
    End If
    
    nMyID = GetCurrentProcessId                         'Get this process's ID
    GetWindowThreadProcessId lng_hWnd, nID              'Get the process ID associated with the window handle
    If nID <> nMyID Then                                'Ensure that the window handle doesn't belong to another process
        zError SUB_NAME, "Window handle belongs to another process"
        Exit Function
    End If
      
    If oCallback Is Nothing Then Set oCallback = Me     'If the user hasn't specified the callback owner
    
    nAddr = zAddressOf(oCallback, nOrdinal)             'Get the address of the specified ordinal method
    If nAddr = 0 Then                                   'Ensure that we've found the ordinal method
        zError SUB_NAME, "Callback method not found"
        Exit Function
    End If
        
    z_ScMem = VirtualAlloc(0, MEM_LEN, MEM_COMMIT, PAGE_RWX) 'Allocate executable memory
    
    If z_ScMem <> 0 Then                                  'Ensure the allocation succeeded
  
        If z_scFunk Is Nothing Then Set z_scFunk = New Collection 'If this is the first time through, do the one-time initialization
        On Error GoTo CatchDoubleSub                              'Catch double subclassing
        z_scFunk.Add z_ScMem, "h" & lng_hWnd                    'Add the hWnd/thunk-address to the collection
        On Error GoTo 0
        
        ' \\Tai Chi Minh Ralph Eastwood - fixed bug where the MSG_AFTER was not being honored
        ' \\LaVolpe - modified thunks to allow auto-unsubclassing when WM_DESTROY received
        z_Sc(14) = &HD231C031: z_Sc(15) = &HBBE58960: z_Sc(16) = &H12345678: z_Sc(17) = &HF63103FF: z_Sc(18) = &H750C4339: z_Sc(19) = &H7B8B4A38: z_Sc(20) = &H95E82C: z_Sc(21) = &H7D810000: z_Sc(22) = &H228&: z_Sc(23) = &HC70C7500: z_Sc(24) = &H20443: z_Sc(25) = &H5E90000: z_Sc(26) = &H39000000: z_Sc(27) = &HF751475: z_Sc(28) = &H25E8&: z_Sc(29) = &H8BD23100: z_Sc(30) = &H6CE8307B: z_Sc(31) = &HFF000000: z_Sc(32) = &H10C2610B: z_Sc(33) = &HC53FF00: z_Sc(34) = &H13D&: z_Sc(35) = &H85BE7400: z_Sc(36) = &HE82A74C0: z_Sc(37) = &H2&: z_Sc(38) = &H75FFE5EB: z_Sc(39) = &H2C75FF30: z_Sc(40) = &HFF2875FF: z_Sc(41) = &H73FF2475: z_Sc(42) = &H1053FF24: z_Sc(43) = &H811C4589: z_Sc(44) = &H13B&: z_Sc(45) = &H39727500:
        z_Sc(46) = &H6D740473: z_Sc(47) = &H2473FF58: z_Sc(48) = &HFFFFFC68: z_Sc(49) = &H873FFFF: z_Sc(50) = &H891453FF: z_Sc(51) = &H7589285D: z_Sc(52) = &H3045C72C: z_Sc(53) = &H8000&: z_Sc(54) = &H8920458B: z_Sc(55) = &H4589145D: z_Sc(56) = &HC4816124: z_Sc(57) = &H4&: z_Sc(58) = &H8B1862FF: z_Sc(59) = &H853AE30F: z_Sc(60) = &H810D78C9: z_Sc(61) = &H4C7&: z_Sc(62) = &H28458B00: z_Sc(63) = &H2975AFF2: z_Sc(64) = &H2873FF52: z_Sc(65) = &H5A1C53FF: z_Sc(66) = &H438D1F75: z_Sc(67) = &H144D8D34: z_Sc(68) = &H1C458D50: z_Sc(69) = &HFF3075FF: z_Sc(70) = &H75FF2C75: z_Sc(71) = &H873FF28: z_Sc(72) = &HFF525150: z_Sc(73) = &H53FF2073: z_Sc(74) = &HC328C328
        
        z_Sc(IDX_EBX) = z_ScMem                                                 'Patch the thunk data address
        z_Sc(IDX_INDEX) = lng_hWnd                                               'Store the window handle in the thunk data
        z_Sc(IDX_BTABLE) = z_ScMem + CODE_LEN                                   'Store the address of the before table in the thunk data
        z_Sc(IDX_ATABLE) = z_ScMem + CODE_LEN + ((MSG_ENTRIES + 1) * 4)         'Store the address of the after table in the thunk data
        z_Sc(IDX_OWNER) = ObjPtr(oCallback)                                     'Store the callback owner's object address in the thunk data
        z_Sc(IDX_CALLBACK) = nAddr                                              'Store the callback address in the thunk data
        z_Sc(IDX_PARM_USER) = lParamUser                                        'Store the lParamUser callback parameter in the thunk data
        
        ' \\LaVolpe - validate unicode request & cache unicode usage
        If bUnicode Then bUnicode = (IsWindowUnicode(lng_hWnd) <> 0&)
        z_Sc(IDX_UNICODE) = bUnicode                                            'Store whether the window is using unicode calls or not
        
        ' \\LaVolpe - added extra parameter "bUnicode" to the zFnAddr calls
        z_Sc(IDX_FREE) = zFnAddr("kernel32", "VirtualFree", bUnicode)           'Store the VirtualFree function address in the thunk data
        z_Sc(IDX_BADPTR) = zFnAddr("kernel32", "IsBadCodePtr", bUnicode)        'Store the IsBadCodePtr function address in the thunk data
        
        Debug.Assert zInIDE
        If bIdeSafety = True And z_IDEflag = 1 Then                             'If the user wants IDE protection
            z_Sc(IDX_EBMODE) = zFnAddr("vba6", "EbMode", bUnicode)                'Store the EbMode function address in the thunk data
        End If
    
        ' \\LaVolpe - use ANSI for non-unicode usage, else use WideChar calls
        If bUnicode Then
            z_Sc(IDX_CWP) = zFnAddr("user32", "CallWindowProcW", bUnicode)          'Store CallWindowProc function address in the thunk data
            z_Sc(IDX_SWL) = zFnAddr("user32", "SetWindowLongW", bUnicode)           'Store the SetWindowLong function address in the thunk data
            z_Sc(IDX_UNICODE) = 1
            RtlMoveMemory z_ScMem, VarPtr(z_Sc(0)), CODE_LEN                        'Copy the thunk code/data to the allocated memory
            nAddr = SetWindowLongW(lng_hWnd, GWL_WNDPROC, z_ScMem + WNDPROC_OFF)    'Set the new WndProc, return the address of the original WndProc
        Else
            z_Sc(IDX_CWP) = zFnAddr("user32", "CallWindowProcA", bUnicode)          'Store CallWindowProc function address in the thunk data
            z_Sc(IDX_SWL) = zFnAddr("user32", "SetWindowLongA", bUnicode)           'Store the SetWindowLong function address in the thunk data
            RtlMoveMemory z_ScMem, VarPtr(z_Sc(0)), CODE_LEN                        'Copy the thunk code/data to the allocated memory
            nAddr = SetWindowLongA(lng_hWnd, GWL_WNDPROC, z_ScMem + WNDPROC_OFF)    'Set the new WndProc, return the address of the original WndProc
        End If
        If nAddr = 0 Then                                                           'Ensure the new WndProc was set correctly
            zError SUB_NAME, "SetWindowLong failed, error #" & Err.LastDllError
            GoTo ReleaseMemory
        End If
        'Store the original WndProc address in the thunk data
        RtlMoveMemory z_ScMem + IDX_WNDPROC * 4, VarPtr(nAddr), 4&              ' z_Sc(IDX_WNDPROC) = nAddr
        ssc_Subclass = True                                                     'Indicate success
    Else
        zError SUB_NAME, "VirtualAlloc failed, error: " & Err.LastDllError
    End If

    Exit Function                                                             'Exit ssc_Subclass
    
CatchDoubleSub:
    zError SUB_NAME, "Window handle is already subclassed"
      
ReleaseMemory:
    VirtualFree z_ScMem, 0, MEM_RELEASE                                       'ssc_Subclass has failed after memory allocation, so release the memory
End Function

'Terminate all subclassing
Private Sub ssc_Terminate()
    ' can be made public. Releases all subclassing
    ' can be removed and zTerminateThunks can be called directly
    zTerminateThunks SubclassThunk
End Sub


Sub UnSubClass(Optional lHwnd As Long = 0)
    If lHwnd = 0 Then
       Call ssc_Terminate
    Else
        Call ssc_UnSubclass(lHwnd)
    End If
End Sub

'UnSubclass the specified window handle
Private Sub ssc_UnSubclass(ByVal lng_hWnd As Long)
    ' can be made public. Releases a specific subclass
    ' can be removed and zUnThunk can be called directly
    zUnThunk lng_hWnd, SubclassThunk
End Sub

'Add the message value to the window handle's specified callback table
Private Sub ssc_AddMsg(ByVal lng_hWnd As Long, ByVal uMsg As Long, Optional ByVal When As eMsgWhen = MSG_AFTER)
    ' Note: can be removed if not needed and zAddMsg can be called directly
    If IsBadCodePtr(zMap_VFunction(lng_hWnd, SubclassThunk)) = 0 Then                 'Ensure that the thunk hasn't already released its memory
        If When And MSG_BEFORE Then                                             'If the message is to be added to the before original WndProc table...
            zAddMsg uMsg, IDX_BTABLE                                              'Add the message to the before table
        End If
        If When And MSG_AFTER Then                                              'If message is to be added to the after original WndProc table...
            zAddMsg uMsg, IDX_ATABLE                                              'Add the message to the after table
        End If
    End If
End Sub

'Delete the message value from the window handle's specified callback table
Private Sub ssc_DelMsg(ByVal lng_hWnd As Long, ByVal uMsg As Long, Optional ByVal When As eMsgWhen = MSG_AFTER)
    ' Note: can be removed if not needed and zDelMsg can be called directly
    If IsBadCodePtr(zMap_VFunction(lng_hWnd, SubclassThunk)) = 0 Then                'Ensure that the thunk hasn't already released its memory
        If When And MSG_BEFORE Then                                             'If the message is to be deleted from the before original WndProc table...
            zDelMsg uMsg, IDX_BTABLE                                              'Delete the message from the before table
        End If
        If When And MSG_AFTER Then                                              'If the message is to be deleted from the after original WndProc table...
            zDelMsg uMsg, IDX_ATABLE                                              'Delete the message from the after table
        End If
    End If
End Sub

'Call the original WndProc
Private Function ssc_CallOrigWndProc(ByVal lng_hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    ' Note: can be removed if you do not use this function inside of your window procedure
    If IsBadCodePtr(zMap_VFunction(lng_hWnd, SubclassThunk)) = 0 Then            'Ensure that the thunk hasn't already released its memory
        If zData(IDX_UNICODE) Then
            ssc_CallOrigWndProc = CallWindowProcW(zData(IDX_WNDPROC), lng_hWnd, uMsg, wParam, lParam) 'Call the original WndProc of the passed window handle parameter
        Else
            ssc_CallOrigWndProc = CallWindowProcA(zData(IDX_WNDPROC), lng_hWnd, uMsg, wParam, lParam) 'Call the original WndProc of the passed window handle parameter
        End If
    End If
End Function

'Get the subclasser lParamUser callback parameter
Private Function zGet_lParamUser(ByVal hWnd_Hook_ID As Long, vType As eThunkType) As Long
    'Note: can be removed if you never need to retrieve/update your user-defined paramter. See ssc_Subclass
    If vType <> CallbackThunk Then
        If IsBadCodePtr(zMap_VFunction(hWnd_Hook_ID, vType)) = 0 Then        'Ensure that the thunk hasn't already released its memory
            zGet_lParamUser = zData(IDX_PARM_USER)                                'Get the lParamUser callback parameter
        End If
    End If
End Function

'Let the subclasser lParamUser callback parameter
Private Sub zSet_lParamUser(ByVal hWnd_Hook_ID As Long, vType As eThunkType, newValue As Long)
    'Note: can be removed if you never need to retrieve/update your user-defined paramter. See ssc_Subclass
    If vType <> CallbackThunk Then
        If IsBadCodePtr(zMap_VFunction(hWnd_Hook_ID, vType)) = 0 Then          'Ensure that the thunk hasn't already released its memory
            zData(IDX_PARM_USER) = newValue                                         'Set the lParamUser callback parameter
        End If
    End If
End Sub

'Add the message to the specified table of the window handle
Private Sub zAddMsg(ByVal uMsg As Long, ByVal nTable As Long)
    Dim nCount As Long                                                        'Table entry count
    Dim nBase  As Long                                                        'Remember z_ScMem
    Dim i      As Long                                                        'Loop index
    
    nBase = z_ScMem                                                           'Remember z_ScMem so that we can restore its value on exit
    z_ScMem = zData(nTable)                                                   'Map zData() to the specified table
    
    If uMsg = ALL_MESSAGES Then                                               'If ALL_MESSAGES are being added to the table...
        nCount = ALL_MESSAGES                                                   'Set the table entry count to ALL_MESSAGES
    Else
        nCount = zData(0)                                                       'Get the current table entry count
        If nCount >= MSG_ENTRIES Then                                           'Check for message table overflow
            zError "zAddMsg", "Message table overflow. Either increase the value of Const MSG_ENTRIES or use ALL_MESSAGES instead of specific message values"
            GoTo Bail
        End If
    
        For i = 1 To nCount                                                     'Loop through the table entries
            If zData(i) = 0 Then                                                  'If the element is free...
                zData(i) = uMsg                                                     'Use this element
                GoTo Bail                                                           'Bail
            ElseIf zData(i) = uMsg Then                                           'If the message is already in the table...
                GoTo Bail                                                           'Bail
            End If
        Next i                                                                  'Next message table entry
    
        nCount = i                                                              'On drop through: i = nCount + 1, the new table entry count
        zData(nCount) = uMsg                                                    'Store the message in the appended table entry
    End If
    
    zData(0) = nCount                                                         'Store the new table entry count
Bail:
    z_ScMem = nBase                                                           'Restore the value of z_ScMem
End Sub

'Delete the message from the specified table of the window handle
Private Sub zDelMsg(ByVal uMsg As Long, ByVal nTable As Long)
    Dim nCount As Long                                                        'Table entry count
    Dim nBase  As Long                                                        'Remember z_ScMem
    Dim i      As Long                                                        'Loop index
    
    nBase = z_ScMem                                                           'Remember z_ScMem so that we can restore its value on exit
    z_ScMem = zData(nTable)                                                   'Map zData() to the specified table
    
    If uMsg = ALL_MESSAGES Then                                               'If ALL_MESSAGES are being deleted from the table...
        zData(0) = 0                                                            'Zero the table entry count
    Else
        nCount = zData(0)                                                       'Get the table entry count
        
        For i = 1 To nCount                                                     'Loop through the table entries
            If zData(i) = uMsg Then                                               'If the message is found...
                zData(i) = 0                                                        'Null the msg value -- also frees the element for re-use
                GoTo Bail                                                           'Bail
            End If
        Next i                                                                  'Next message table entry
        
        zError "zDelMsg", "Message &H" & Hex$(uMsg) & " not found in table"
    End If
      
Bail:
    z_ScMem = nBase                                                           'Restore the value of z_ScMem
End Sub

'-SelfCallback code------------------------------------------------------------------------------------
'-The following routines are exclusively for the scb_SetCallbackAddr routines----------------------------
Private Function scb_SetCallbackAddr(ByVal nParamCount As Long, _
       Optional ByVal nOrdinal As Long = 1, _
       Optional ByVal oCallback As Object = Nothing, _
       Optional ByVal bIdeSafety As Boolean = True) As Long   'Return the address of the specified callback thunk
    '*************************************************************************************************
    '* nParamCount  - The number of parameters that will callback
    '* nOrdinal     - Callback ordinal number, the final private method is ordinal 1, the second last is ordinal 2, etc...
    '* oCallback    - Optional, the object that will receive the callback. If undefined, callbacks are sent to this object's instance
    '* bIdeSafety   - Optional, set to false to disable IDE protection.
    '*************************************************************************************************
    ' Callback procedure must return a Long even if, per MSDN, the callback procedure is a Sub vs Function
    ' The number of parameters are dependent on the individual callback procedures
    
    Const MEM_LEN     As Long = IDX_CALLBACKORDINAL * 4 + 4     'Memory bytes required for the callback thunk
    Const PAGE_RWX    As Long = &H40&                           'Allocate executable memory
    Const MEM_COMMIT  As Long = &H1000&                         'Commit allocated memory
    Const SUB_NAME      As String = "scb_SetCallbackAddr"       'This routine's name
    Const INDX_OWNER    As Long = 0
    Const INDX_CALLBACK As Long = 1
    Const INDX_EBMODE   As Long = 2
    Const INDX_BADPTR   As Long = 3
    Const INDX_EBX      As Long = 5
    Const INDX_PARAMS   As Long = 12
    Const INDX_PARAMLEN As Long = 17

    Dim z_Cb()    As Long    'Callback thunk array
    Dim nCallback As Long
      
    If z_cbFunk Is Nothing Then
        Set z_cbFunk = New Collection           'If this is the first time through, do the one-time initialization
    Else
        On Error Resume Next                    'Catch already initialized?
        z_ScMem = z_cbFunk.Item("h" & nOrdinal) 'Test it
        If Err = 0 Then
            scb_SetCallbackAddr = z_ScMem + 16  'we had this one, just reference it
            Exit Function
        End If
        On Error GoTo 0
    End If
    
    If nParamCount < 0 Then                     ' validate parameters
        zError SUB_NAME, "Invalid Parameter count"
        Exit Function
    End If
    
    If oCallback Is Nothing Then Set oCallback = Me     'If the user hasn't specified the callback owner
    nCallback = zAddressOf(oCallback, nOrdinal)         'Get the callback address of the specified ordinal
    If nCallback = 0 Then
        zError SUB_NAME, "Callback address not found."
        Exit Function
    End If
    z_ScMem = VirtualAlloc(0, MEM_LEN, MEM_COMMIT, PAGE_RWX) 'Allocate executable memory
        
    If z_ScMem = 0& Then
        zError SUB_NAME, "VirtualAlloc failed, error: " & Err.LastDllError  ' oops
        Exit Function
    End If
    z_cbFunk.Add z_ScMem, "h" & nOrdinal                  'Add the callback/thunk-address to the collection
        
    ReDim z_Cb(0 To IDX_CALLBACKORDINAL) As Long          'Allocate for the machine-code array
    
    ' Create machine-code array
    z_Cb(4) = &HBB60E089: z_Cb(6) = &H73FFC589: z_Cb(7) = &HC53FF04: z_Cb(8) = &H7B831F75: z_Cb(9) = &H20750008: z_Cb(10) = &HE883E889: z_Cb(11) = &HB9905004: z_Cb(13) = &H74FF06E3: z_Cb(14) = &HFAE2008D: z_Cb(15) = &H53FF33FF: z_Cb(16) = &HC2906104: z_Cb(18) = &H830853FF: z_Cb(19) = &HD87401F8: z_Cb(20) = &H4589C031: z_Cb(21) = &HEAEBFC
    
    z_Cb(INDX_BADPTR) = zFnAddr("kernel32", "IsBadCodePtr", False)
    z_Cb(INDX_OWNER) = ObjPtr(oCallback)                  'Set the Owner
    z_Cb(INDX_CALLBACK) = nCallback                       'Set the callback address
    z_Cb(IDX_CALLBACKORDINAL) = nOrdinal                  'Cache ordinal used for zTerminateThunks
      
    Debug.Assert zInIDE
    If bIdeSafety = True And z_IDEflag = 1 Then             'If the user wants IDE protection
        z_Cb(INDX_EBMODE) = zFnAddr("vba6", "EbMode", False)  'EbMode Address
    End If
        
    z_Cb(INDX_PARAMS) = nParamCount                         'Set the parameter count
    z_Cb(INDX_PARAMLEN) = nParamCount * 4                   'Set the number of stck bytes to release on thunk return
      
    '\\LaVolpe - redirect address to proper location in virtual memory. Was: z_Cb(INDX_EBX) = VarPtr(z_Cb(INDX_OWNER))
    z_Cb(INDX_EBX) = z_ScMem                                'Set the data address relative to virtual memory pointer
      
    RtlMoveMemory z_ScMem, VarPtr(z_Cb(INDX_OWNER)), MEM_LEN 'Copy thunk code to executable memory
    scb_SetCallbackAddr = z_ScMem + 16                       'Thunk code start address
    
End Function

Private Sub scb_ReleaseCallback(ByVal nOrdinal As Long)
    ' can be made public. Releases a specific callback
    ' can be removed and zUnThunk can be called directly
    zUnThunk nOrdinal, CallbackThunk
End Sub
Private Sub scb_TerminateCallbacks()
    ' can be made public. Releases all callbacks
    ' can be removed and zTerminateThunks can be called directly
    zTerminateThunks CallbackThunk
End Sub


'========================================================================
' COMMON USE ROUTINES
'-The following routines are used for each of the three types of thunks
'========================================================================

'Map zData() to the thunk address for the specified window handle
Private Function zMap_VFunction(ByVal vFuncTarget As Long, vType As eThunkType) As Long
    
    ' vFuncTarget is one of the following, depending on vType
    '   - Subclassing:  the hWnd of the window subclassed
    '   - Hooking:      the hook type created
    '   - Callbacks:    the ordinal of the callback
    
    Dim thunkCol As Collection
    
    If vType = CallbackThunk Then
        Set thunkCol = z_cbFunk
    ElseIf vType = HookThunk Then
        Set thunkCol = z_hkFunk
    ElseIf vType = SubclassThunk Then
        Set thunkCol = z_scFunk
    Else
        zError "zMap_Vfunction", "Invalid thunk type passed"
        Exit Function
    End If
    
    If thunkCol Is Nothing Then
        zError "zMap_VFunction", "Thunk hasn't been initialized"
    Else
        On Error GoTo Catch
        z_ScMem = thunkCol("h" & vFuncTarget)                    'Get the thunk address
        zMap_VFunction = z_ScMem
    End If
    Exit Function                                               'Exit returning the thunk address
    
Catch:
    zError "zMap_VFunction", "Thunk type for ID of " & vFuncTarget & " does not exist"
End Function

'Error handler
Private Sub zError(ByVal sRoutine As String, ByVal sMsg As String)
    ' \\LaVolpe -  Note. These two lines can be rem'd out if you so desire. But don't remove the routine
    App.LogEvent TypeName(Me) & "." & sRoutine & ": " & sMsg, vbLogEventTypeError
    MsgBox sMsg & ".", vbExclamation + vbApplicationModal, "Error in " & TypeName(Me) & "." & sRoutine
End Sub

'Return the address of the specified DLL/procedure
Private Function zFnAddr(ByVal sDLL As String, ByVal sProc As String, ByVal asUnicode As Boolean) As Long
    If asUnicode Then
        zFnAddr = GetProcAddress(GetModuleHandleW(StrPtr(sDLL)), sProc)         'Get the specified procedure address
    Else
        zFnAddr = GetProcAddress(GetModuleHandleA(sDLL), sProc)                 'Get the specified procedure address
    End If
    Debug.Assert zFnAddr                                                      'In the IDE, validate that the procedure address was located
    ' ^^ FYI VB5 users. Search for zFnAddr("vba6", "EbMode") and replace with zFnAddr("vba5", "EbMode")
End Function

'Return the address of the specified ordinal method on the oCallback object, 1 = last private method, 2 = second last private method, etc
Private Function zAddressOf(ByVal oCallback As Object, ByVal nOrdinal As Long) As Long
    ' Note: used both in subclassing and hooking routines
    Dim bSub  As Byte                                                         'Value we expect to find pointed at by a vTable method entry
    Dim bVal  As Byte
    Dim nAddr As Long                                                         'Address of the vTable
    Dim i     As Long                                                         'Loop index
    Dim j     As Long                                                         'Loop limit
  
    RtlMoveMemory VarPtr(nAddr), ObjPtr(oCallback), 4                         'Get the address of the callback object's instance
    If Not zProbe(nAddr + &H1C, i, bSub) Then                                 'Probe for a Class method
        If Not zProbe(nAddr + &H6F8, i, bSub) Then                              'Probe for a Form method
            ' \\LaVolpe - Added propertypage offset
            If Not zProbe(nAddr + &H710, i, bSub) Then                            'Probe for a PropertyPage method
                If Not zProbe(nAddr + &H7A4, i, bSub) Then                          'Probe for a UserControl method
                    Exit Function                                                   'Bail...
                End If
            End If
        End If
    End If
  
    i = i + 4                                                                 'Bump to the next entry
    j = i + 1024                                                              'Set a reasonable limit, scan 256 vTable entries
    Do While i < j
        RtlMoveMemory VarPtr(nAddr), i, 4                                       'Get the address stored in this vTable entry
    
        If IsBadCodePtr(nAddr) Then                                             'Is the entry an invalid code address?
            RtlMoveMemory VarPtr(zAddressOf), i - (nOrdinal * 4), 4               'Return the specified vTable entry address
            Exit Do                                                               'Bad method signature, quit loop
        End If

        RtlMoveMemory VarPtr(bVal), nAddr, 1                                    'Get the byte pointed to by the vTable entry
        If bVal <> bSub Then                                                    'If the byte doesn't match the expected value...
            RtlMoveMemory VarPtr(zAddressOf), i - (nOrdinal * 4), 4               'Return the specified vTable entry address
            Exit Do                                                               'Bad method signature, quit loop
        End If
    
        i = i + 4                                                               'Next vTable entry
    Loop
End Function

'Probe at the specified start address for a method signature
Private Function zProbe(ByVal nStart As Long, ByRef nMethod As Long, ByRef bSub As Byte) As Boolean
    Dim bVal    As Byte
    Dim nAddr   As Long
    Dim nLimit  As Long
    Dim nEntry  As Long
  
    nAddr = nStart                                                            'Start address
    nLimit = nAddr + 32                                                       'Probe eight entries
    Do While nAddr < nLimit                                                   'While we've not reached our probe depth
        RtlMoveMemory VarPtr(nEntry), nAddr, 4                                  'Get the vTable entry
    
        If nEntry <> 0 Then                                                     'If not an implemented interface
            RtlMoveMemory VarPtr(bVal), nEntry, 1                                 'Get the value pointed at by the vTable entry
            If bVal = &H33 Or bVal = &HE9 Then                                    'Check for a native or pcode method signature
                nMethod = nAddr                                                     'Store the vTable entry
                bSub = bVal                                                         'Store the found method signature
                zProbe = True                                                       'Indicate success
                Exit Do                                                             'Return
            End If
        End If
    
        nAddr = nAddr + 4                                                       'Next vTable entry
    Loop
End Function

Private Function zInIDE() As Long
    ' This is only run in IDE; it is never run when compiled
    z_IDEflag = 1
    zInIDE = z_IDEflag
End Function

Private Property Get zData(ByVal nIndex As Long) As Long
    ' retrieves stored value from virtual function's memory location
    RtlMoveMemory VarPtr(zData), z_ScMem + (nIndex * 4), 4
End Property

Private Property Let zData(ByVal nIndex As Long, ByVal nValue As Long)
    ' sets value in virtual function's memory location
    RtlMoveMemory z_ScMem + (nIndex * 4), VarPtr(nValue), 4
End Property

Private Sub zUnThunk(ByVal thunkID As Long, ByVal vType As eThunkType)
    ' Releases a specific subclass, hook or callback
    ' thunkID depends on vType:
    '   - Subclassing:  the hWnd of the window subclassed
    '   - Hooking:      the hook type created
    '   - Callbacks:    the ordinal of the callback

    Const IDX_SHUTDOWN  As Long = 1
    Const MEM_RELEASE As Long = &H8000&                                'Release allocated memory flag
    
    If zMap_VFunction(thunkID, vType) Then
        Select Case vType
            Case SubclassThunk
                If IsBadCodePtr(z_ScMem) = 0 Then       'Ensure that the thunk hasn't already released its memory
                    zData(IDX_SHUTDOWN) = 1             'Set the shutdown indicator
                    zDelMsg ALL_MESSAGES, IDX_BTABLE    'Delete all before messages
                    zDelMsg ALL_MESSAGES, IDX_ATABLE    'Delete all after messages
                    '\\LaVolpe - Force thunks to replace original window procedure handle. Without this, app can crash when a window is subclassed multiple times simultaneously
                    If zData(IDX_UNICODE) Then          'Force window procedure handle to be replaced
                        SendMessageW thunkID, 0&, 0&, ByVal 0&
                    Else
                        SendMessageA thunkID, 0&, 0&, ByVal 0&
                    End If
                End If
                z_scFunk.Remove "h" & thunkID           'Remove the specified thunk from the collection
            Case HookThunk
                If IsBadCodePtr(z_ScMem) = 0 Then       'Ensure that the thunk hasn't already released its memory
                    zData(IDX_SHUTDOWN) = 1             'Set the shutdown indicator
                    zData(IDX_ATABLE) = 0               ' want no more After messages
                    zData(IDX_BTABLE) = 0               ' want no more Before messages
                End If
                z_hkFunk.Remove "h" & thunkID           'Remove the specified thunk from the collection
            Case CallbackThunk
                If IsBadCodePtr(z_ScMem) = 0 Then       'Ensure that the thunk hasn't already released its memory
                    VirtualFree z_ScMem, 0, MEM_RELEASE 'Release allocated memory
                End If
                z_cbFunk.Remove "h" & thunkID           'Remove the specified thunk from the collection
        End Select
    End If

End Sub

Private Sub zTerminateThunks(ByVal vType As eThunkType)
    ' Removes all thunks of a specific type: subclassing, hooking or callbacks
    Dim i As Long
    Dim thunkCol As Collection
    
    Select Case vType
        Case SubclassThunk
            Set thunkCol = z_scFunk
        Case HookThunk
            Set thunkCol = z_hkFunk
        Case CallbackThunk
            Set thunkCol = z_cbFunk
        Case Else
            Exit Sub
    End Select
    
    If Not (thunkCol Is Nothing) Then                 'Ensure that hooking has been started
        With thunkCol
            For i = .Count To 1 Step -1                   'Loop through the collection of hook types in reverse order
                z_ScMem = .Item(i)                          'Get the thunk address
                If IsBadCodePtr(z_ScMem) = 0 Then           'Ensure that the thunk hasn't already released its memory
                    Select Case vType
                        Case SubclassThunk
                            zUnThunk zData(IDX_INDEX), SubclassThunk     'Unsubclass
                        Case HookThunk
                            zUnThunk zData(IDX_INDEX), HookThunk             'Unhook
                        Case CallbackThunk
                            zUnThunk zData(IDX_CALLBACKORDINAL), CallbackThunk ' release callback
                    End Select
                End If
            Next i                                        'Next member of the collection
        End With
        Set thunkCol = Nothing                         'Destroy the hook/thunk-address collection
    End If

End Sub



'-------------------------------------------------------------------------------
' Inicar Hooks y agregar los mensajes para el form y el control
'-------------------------------------------------------------------------------

Private Function SubClass(ByVal lHwnd As Long) As Boolean

    If ssc_Subclass(lHwnd) Then
        If lHwnd = m_hwndOwner Then
            ' agregar todos los mensajes para form principal ( ALL_MESSAGES - 1 )
            ssc_AddMsg lHwnd, ALL_MESSAGES, MSG_BEFORE
            
        ' Agregar mensajes para el control asociado al menu
        ElseIf lHwnd = m_CotrolHwnd Then
            ssc_AddMsg lHwnd, 8, MSG_BEFORE ' para cuando pierde el foco
            ssc_AddMsg lHwnd, 256, MSG_BEFORE
        End If
    End If
End Function



'- ordinal #1
Private Sub WndProc(ByVal bBefore As Boolean, _
       ByRef bHandled As Boolean, _
       ByRef lReturn As Long, _
       ByVal hwnd As Long, _
       ByVal uMsg As Long, _
       ByVal wParam As Long, _
       ByVal lParam As Long, _
       ByRef lParamUser As Long)
    
On Error GoTo error_handler
        
       Select Case hwnd
            
           '-------------------------------------------------------------------------------
           ' Mensajes para el contenedor del men
           '-------------------------------------------------------------------------------
           Case m_hwndOwner
           
                
                ' Mensaje cuando se despliega el men de sistema de la ventana o se cierra
                '-------------------------------------------------------------------------------
                
                If uMsg = WM_SYSCOMMAND And wParam = SC_CLOSE Then
                    ' ocultar le men para salir
                    Me.Visible = False
                    Exit Sub
                End If
                
                ' ocultar le men para salir cuando se hace clic en el form
                If uMsg = WM_RBUTTONDOWN Or uMsg = WM_LBUTTONDOWN Then
                   Me.Visible = False
                   Exit Sub
                End If
                
                If uMsg = 307 Or uMsg = 273 Then
                    'Debug.Print uMsg
                Else
                    If uMsg <> 123 And _
                        uMsg <> 124 And _
                        uMsg <> 125 And _
                        uMsg <> 60 And _
                        uMsg <> 174 And _
                        uMsg <> 132 And _
                        uMsg <> 512 And _
                        uMsg <> 127 And _
                        uMsg <> 70 And _
                        uMsg <> 32 And _
                        uMsg <> 160 And _
                        uMsg <> 674 And _
                        uMsg <> 134 And _
                        uMsg <> 514 And _
                        uMsg <> 533 And _
                        uMsg <> 517 And _
                        uMsg <> 13 And _
                        uMsg <> 14 And _
                        uMsg <> 78 Then
                        
                            Me.Visible = False
                    End If
                End If
           ' -------------------------------------------------------------------------------
           ' Mensajes para el Control que tiene el foco (control asociado el men)
           ' -------------------------------------------------------------------------------
           Case m_CotrolHwnd
                Select Case uMsg
                    Case 8
                        ' Para cuando pierde el foco el control
                        Me.Visible = False
                    Case 256
                        If wParam = 40 Then
                           SelectIndex 1
                        End If
                        If wParam = 38 Then
                           SelectIndex -1
                        End If
                        If wParam = 13 Then
                           Call Acept
                        End If
                        If wParam = 27 Then
                           Me.Visible = False
                        End If
                    End Select
       End Select
       
Exit Sub
error_handler:
Debug.Print Err.Description
End Sub


'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Importante !! : NO colocar ningn cdigo debajo de WndProc
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
